C------------ /QJMACS/ --- Buffer for jet and topological routines -----
         INTEGER JTBIMX,JTBOMX,JPARMX,JTBI,JTBIT,JTBO,JTBOF
         DOUBLE PRECISION QPI,QTBIR,QPO,QTBOR
         PARAMETER (JTBIMX =10000,JTBOMX = 30,JPARMX = 5)
         COMMON /QCTBUF/QPI(5,JTBIMX),QTBIR(JPARMX,JTBIMX),
     +                  QPO(5,JTBOMX),QTBOR(JPARMX,JTBOMX),
     +                  JTBI,JTBIT(JTBIMX),
     +                  JTBO,JTBOF(JPARMX,JTBIMX)
C     jtbi       number of input vectors (max : jtbimx).
C     qpi(i,j)   particle input vector j; i=1,2,3,4:px,py,pz,e; i=5 free
C     jtbit(j)   pointer to corresponding q-vector
C     qtbir(k,j) scalar input k for each input vector j
C     jtbo       number of output jets   (max : jtbomx)
C     qpo(i,j)   jet output vector (jet axis) i=1,2,3,4:px,py,pz,e
C     jtbof(k,i) number of jet for input particle i in multiplet k
C     qtbor(k,j) scalar output result k for each jet j (k_max : jparmx)
C                (will be stored as user words in Q_vector)
*
