      subroutine hz01100(IFLAG)
***********************************************
* F2cc data H1 and D* cross sections
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      real p,pt,et,rap,th,phdum,phang,xd,dst_xsec
      real ps,pts,ets,raps,ths,phangs
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact,lumnb

      Integer iqbin,i1,i3,idhisto,idpaw
      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=10000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2,nall3
      Real xw
      Data nall/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real x,y,w2,q2

      double precision dq
      real f2pdf
      DOUBLE PRECISION XXX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20)
      CHARACTER*20 PARM(20)
      Integer npdf
      DATA NPDF/0/,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU/9*0.D0/
      LOGICAL PDFFIRST
      COMMON /W50516/PDFFIRST
*
*
* F2 data
*
      Integer nf2
      Parameter (nf2=9)

      Real myqbin(7)
      Data myqbin/1.0,1.8,5.5,8,18,35,110./
      Real q2b(6)
      data q2b/1.5,3.5,6.5,12.0,25.0,60.0/
      Real trueqbin(10)
      data trueqbin/1.,2.185,2.88,4.25,10.,14.4,19.,34.1,40.,100./

      Real q2binw(8)
      Integer nxbin
      Parameter  (nxbin=15)
      Integer nxbin1
      Parameter  (nxbin1=2)
      Real xbin(nxbin+1)
      Real xbin1(nxbin1+1),xbin2(nxbin1+1),xbin3(nxbin1+1)
      Real xbin4(nxbin1+1),xbin5(nxbin1+1),xbin6(nxbin1+1)
      data xbin1/0.0000158,0.00012,0.0004/
      data xbin2/0.0000251,0.0003,0.0009/
      data xbin3/0.0001   ,0.0003,0.0007/
      data xbin4/0.000251,0.001,0.004/
      data xbin5/0.000251,0.0008,0.005/
      data xbin6/0.0015,0.00251,0.004/
	Real svis1(2),svis2(2),svis3(2),svis4(2),svis5(2),svis6(2)
	Real esvis1(2),esvis2(2),esvis3(2),esvis4(2),esvis5(2),esvis6(2)
	Data svis1/1.11,1.44/
	data esvis1/0.19,0.28/
	data svis2/0.95,0.41/
	data esvis2/0.13,0.07/
	data svis3/0.72,1.02/
	data esvis3/0.10,0.11/
	data svis4/0.59,0.43/
	data esvis4/0.09,0.07/
	data svis5/0.33,0.54/
	data esvis5/0.06,0.07/
	data svis6/0.31,0.35/
	data esvis6/0.06,0.06/
	
      Real xx1(nxbin1),yy1(nxbin1)
      Real xx2(nxbin1),yy2(nxbin1)
      Real xx3(nxbin1),yy3(nxbin1)
      Real xx4(nxbin1),yy4(nxbin1)
      Real xx5(nxbin1),yy5(nxbin1)
      Real xx6(nxbin1),yy6(nxbin1)
      Real f2_1(nxbin+2),f2_2(nxbin+2),f2_3(nxbin+2)
      Real ef2_1(nxbin+2),ef2_2(nxbin+2),ef2_3(nxbin+2)
      Real eft_1(nxbin+2),eft_2(nxbin+2),eft_3(nxbin+2)
      Real f2_4(nxbin+2),f2_5(nxbin+2),f2_6(nxbin+2)
      Real ef2_4(nxbin+2),ef2_5(nxbin+2),ef2_6(nxbin+2)
      Real eft_4(nxbin+2),eft_5(nxbin+2),eft_6(nxbin+2)
      
      Real eyy1(nxbin1),eyy2(nxbin1),eyy3(nxbin1)
      Real eyy4(nxbin1),eyy5(nxbin1),eyy6(nxbin1)
      Real esy1(nxbin1),esy2(nxbin1),esy3(nxbin1)
      Real esy4(nxbin1),esy5(nxbin1),esy6(nxbin1)
      Integer nxb
      Parameter(nxb=8)
      Real truexbin(nxb+1)
      Data truexbin/0.00004,0.000062,0.00017,0.00025,
     +            0.0004, 0.00062, 0.0017, 0.0025, 0.0041/
      Real truex(5)
      Data truex/5.e-5,2.e-4,5.e-4,2.e-3,3.2e-3/
      Real xbinw(5)
	Real qbin(31)
      Real conten(nxbin),contene(nxbin)

      Real q2bin(8)
      Real nq2bin(8)


      Real conten2(30),contene2(30)
      Integer ixbin


* f2cc data from H1 Phys. Lett. B 528, 199-214 (2002) DESY 01-100
*    f2 Q2=1.5 (bin 1)
      Data xx1/0.05e-3, 0.2e-3/
      Data yy1/0.114, 0.053/
      Data eyy1/0.019, 0.010/
      Data esy1/0.019, 0.021/

*    f2 Q2=3.5 (bin 2)
      Data xx2/0.13e-3, 0.5e-3/
      Data yy2/0.161, 0.082/
      Data eyy2/0.022, 0.015/
      Data esy2/0.023, 0.022/

*    f2 Q2=6.5 (bin 3)
      Data xx3/0.2e-3, 0.5e-3/
      Data yy3/0.309, 0.151/
      Data eyy3/0.041, 0.017/
      Data esy3/0.116, 0.032/

*    f2 Q2=12.0 (bin 4)
      Data xx4/0.5e-3, 2.0e-3/
      Data yy4/0.276, 0.174/
      Data eyy4/0.040, 0.029/
      Data esy4/0.052, 0.064/

*    f2 Q2=25 (bin 5)
      Data xx5/0.5e-3, 2.0e-3/
      Data yy5/0.508,  0.278/
      Data eyy5/0.096, 0.037/
      Data esy5/0.125, 0.035/

*    f2 Q2=60 (bin 6)
      Data xx6/2.0e-3, 3.16e-3/
      Data yy6/0.348, 0.272/
      Data eyy6/0.066, 0.050/
      Data esy6/0.077, 0.067/
      
* Data for dsigma/dQ2
      Integer nq2
      Parameter (nq2=6)
      Real sq2(nq2),esq2(nq2),ssq2(nq2),dq2(nq2+1)
      Data dq2/1.0,2.371,4.217,10.0,17.78,31.62,100./

* Data for dsigma/dx
      Integer nx
      Parameter (nx=4)
      Real sx(nx),esx(nx),ssx(nx),dx(nx+1)
c      Data dx/0.0000158,0.00010,0.000251,0.001,0.01 /
      Data dx/-4.8,-4,-3.6,-3,-2 /
* Data for dsigma/dW
      Integer nW
      Parameter (nW=4)
      Real sW(nW),esW(nW),esWu(nW),esWd(nW),dW(nW+1)
      Data dW  / 60., 110., 160., 210., 260./
	data sw  /0.0528,0.0600,0.0373,0.0209/
	data esw /0.0040,0.0042,0.0035,0.0030/
	data eswu/0.0084,0.0124,0.0098,0.0044/
	data eswd/0.0086,0.0080,0.0054,0.0063/
* Data for dsigma/dxd
      Integer nxd
      Parameter (nxd=7)
      Real sxd(nxd),esxd(nxd),esxdu(nxd),esxdd(nxd),dxd(nxd+1)
      Data dxd  /0.0, 0.1,  0.2,  0.3,   0.4,   0.5,  0.7, 1.0/
	data sxd  /7.658,19.399,14.299,12.266,13.212,6.217,1.742/
	data esxd /1.733,2.114,1.588,1.344,1.292,0.616,0.198/
	data esxdu/3.110,3.484,3.826,3.876,2.869,1.689,0.540/
	data esxdd/2.127,4.726,2.118,2.973,2.953,1.214,0.780/

	
* Data for dsigma/dpt
      Integer npt
      Parameter (npt=5)
      Real spt(npt),espt(npt),eptu(npt),eptd(npt),dpt(npt+1)
      Data dpt / 1.5, 2.0, 2.5, 3.5, 5.0, 15.0/
	Data spt /3.918,3.840,1.990,0.810,0.113/
	Data espt/0.645,0.401,0.151,0.063,0.012/
	Data eptu/1.028,0.885,0.304,0.130,0.018/
	Data eptd/0.751,0.551,0.247,0.115,0.016/
* Data for dsigma/deta
      Integer neta
      Parameter (neta=4)
      Real seta(neta),eseta(neta),esetu(neta),esetd(neta),deta(neta+1)
      data deta /-1.5,-0.75,0.,0.75,1.5/
	data seta /2.355,2.767,3.414,2.682/
	data eseta/0.219,0.223,0.266,0.295/
	data esetu/0.479,0.528,0.672,0.506/
	data esetd/0.340,0.352,0.490,0.579/
      real delta
      real sigm,phip,beta,t,x_pom,xmas,ymas

* Data for dsigma/dptdq2
      Integer n1pt,n1q2
      Parameter (n1pt=2,n1q2=4)
      Real x1pt(n1pt+1),x1q2(n1q2+1)
      Data x1pt/1.5,4.0,10.0/
      Data x1q2/1.,3.,8.5,20.,100./
	Real sp1q2(4),esp1q2(4),esp1q2u(4),esp1q2d(4)
	Real sp2q2(4),esp2q2(4),esp2q2u(4),esp2q2d(4)
	data sp1q2/0.5425,0.1608,0.0461,0.0047/
	data sp2q2/0.0244,0.0082,0.0032,0.0008/
	data esp1q2/0.0608,0.0137,0.0048,0.0006/
	data esp2q2/0.0042,0.0012,0.0005,0.0001/
	data esp1q2u/0.1027,0.0363,0.0107,0.0009/
	data esp2q2u/0.0069,0.0015,0.0007,0.0001/
	data esp1q2d/0.1004,0.0216,0.0063,0.0009/
	data esp2q2d/0.0048,0.0018,0.0006,0.0002/
* data for dsigma/dq2deta
      Integer n2q2,n2eta
      Parameter (n2q2=3,n2eta=3)
      Real x2q2(n2q2+1),x2eta(n2eta+1)
      Data x2q2/1.,8.5,20.,100./
      Data x2eta/-1.5,-0.5,0.5,1.5/
	Real seta1q2(3),seta1q2e(3),seta1q2u(3),seta1q2d(3)
	Data seta1q2 /0.2235,0.0414,0.0050/
	data seta1q2e/0.0230,0.0062,0.0008/
	data seta1q2u/0.0603,0.0088,0.0014/
      data seta1q2d/0.0309,0.0073,0.0010/
	Real seta2q2(3),seta2q2e(3),seta2q2u(3),seta2q2d(3)
	Data seta2q2 /0.2664,0.0509,0.0061/
	Data seta2q2e/0.0246,0.0068,0.0009/
	Data seta2q2u/0.0489,0.0116,0.0011/
	Data seta2q2d/0.0423,0.0139,0.0012/
	Real seta3q2(3),seta3q2e(3),seta3q2u(3),seta3q2d(3)
	Data seta3q2 /0.2900,0.0382,0.0065/
	Data seta3q2e/0.0311,0.0069,0.0011/
	Data seta3q2u/0.0485,0.0165,0.0017/
	Data seta3q2d/0.0727,0.0081,0.0016/
* data for dsigma/dptdeta
      Integer n3pt,n3eta
      Parameter (n3pt=3,n3eta=3)
      Real x3pt(n3pt+1),x3eta(n3eta+1)
      Data x3pt/1.5,2.5,4.0,10./
      Data x3eta/-1.5,-0.5,0.5,1.5/
	Real spt1eta(3),spt1etae(3),spt1etau(3),spt1etad(3)
	data spt1eta /1.3196,1.3506,1.6046/
	data spt1etae/0.1845,0.2071,0.2376/
	data spt1etau/0.4199,0.3196,0.4314/
	Real spt2eta(3),spt2etae(3),spt2etau(3),spt2etad(3)
	data spt2eta /0.5147,0.6840,0.4198/
	data spt2etae/0.0571,0.0680,0.0648/
	data spt2etau/0.0853,0.1251,0.1307/
	data spt2etad/0.0870,0.0925,0.0866/
	Real spt3eta(3),spt3etae(3),spt3etau(3),spt3etad(3)
	data spt3eta /0.0460,0.0629,0.0842/
	data spt3etae/0.0066,0.0082,0.0103/
	data spt3etau/0.0113,0.0135,0.0143/
	data spt3etad/0.0078,0.0103,0.0209/

* data for dsigma/dptdxd
      Integer n4pt,n4xd
      Parameter (n4pt=3,n4xd=3)
      Real x4pt(n4pt+1),x4xd(n4xd+1)
      Data x4pt/1.5,2.5,4.0,10./
      Data x4xd/0.,0.25,0.5,1./
	Real spt1xd(3),spt1xde(3),spt1xdu(3),spt1xdd(3)
      data spt1xd /8.3832,5.6722,1.2774/
	data spt1xde/1.1960,0.7614,0.2162/
	data spt1xdu/1.9321,1.8335,0.5924/
	data spt1xdd/2.0163,0.9158,0.3428/
	Real spt2xd(3),spt2xde(3),spt2xdu(3),spt2xdd(3)
      data spt2xd /2.0220,3.0068,0.9992/
	data spt2xde/0.2665,0.2610,0.1019/
	data spt2xdu/0.6061,0.4817,0.2140/
	data spt2xdd/0.3614,0.6322,0.1995/
	Real spt3xd(3),spt3xde(3),spt3xdu(3),spt3xdd(3)
	data spt3xd /0.2067,0.2770,0.1377/
	data spt3xde/0.0325,0.0330,0.0169/
	data spt3xdu/0.0869,0.0847,0.0286/
	data spt3xdd/0.0576,0.0455,0.0386/
* data for dsigma/deta/dxd
      Integer n5eta,n5xd
      Parameter (n5eta=3,n5xd=3)
      Real x5eta(n5eta+1),x5xd(n5xd+1)
      Data x5eta/-1.5,-0.5,0.5,1.5/
      Data x5xd/0.,0.25,0.5,1./
	Real szd1eta(3),szd1etae(3),szd1etau(3),szd1etad(3)
	Data szd1eta /2.0345,4.3568,6.5932/
	Data szd1etae/0.5213,0.6245,0.8290/
	Data szd1etau/0.8814,1.0058,1.6881/
	Data szd1etad/0.5756,0.9133,1.4836/
	Real szd2eta(3),szd2etae(3),szd2etau(3),szd2etad(3)
	Data szd2eta /4.9894,4.2646,3.9122/
	Data szd2etae/0.5427,0.4631,0.4833/
	Data szd2etau/1.1322,0.9243,1.1136/
	Data szd2etad/0.7863,0.8311,1.1043/
	Real szd3eta(3),szd3etae(3),szd3etau(3),szd3etad(3)
	Data szd3eta /1.6384,1.6457,0.5962/
	Data szd3etae/0.1779,0.1753,0.1260/
	Data szd3etau/0.4088,0.5089,0.1472/
	Data szd3etad/0.2698,0.4068,0.3070/
*
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Double precision plab(5,NMXHEP)
      Integer iflag,ihep,i,j,k,l
      Logical charm,ldstar
      Real ptdcut,rapcut,ylcut,yhcut,q2lcut,q2hcut
      Integer ndstar,idstar
      Real xlunorm
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'01100'/
      Real xcharm,xdstar,brat,bratn
      common/cwnco1/x,y,Q2
      Integer iq(9)
      Data iq/1,-10,2,3,4,-10,5,-10,6/
      Integer ix(8)
      Data ix/1,-10,2,-10,3,-10,4,5/

      save xcharm, xdstar, Qpi, qqradp, xbinw, q2binw, delta

*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
         xcharm = 0.
         xdstar = 0.
*
         write(6,*)' hz01100 my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
         delta = 4.
         do i=1,nxbin+1
            xbin(i) = 10**(-5 + delta*(i-1)/nxbin)
c        write(6,*) ' xbin ',i,xbin(i)
         enddo
	 
c	 xbin1(1)=xx1(1)-(xx1(2)-xx1(1))/20.
c         do I = 1,nxbin1
c            xbin(i) = xcent(i) + (xcent(i+1)-xcent(i))/2.
c            xbin1(i+1) = 2*xx1(i) - xbin1(i)
c        write(6,*) ' xbin 1 ',i,xbin1(i),xx1(i)
c         enddo
c         xbin2(1)=xx2(1)-(xx2(2)-xx2(1))/20.
c         do I = 1,nxbin1
c            xbin2(i+1) = 2*xx2(i) - xbin2(i)
c        write(6,*) ' xbin 2 ',i,xbin2(i),xx2(i)
c         enddo
c         xbin3(1)=xx3(1)-(xx3(2)-xx3(1))/20.
c         do I = 1,nxbin1
c            xbin3(i+1) = 2*xx3(i) - xbin3(i)
c        write(6,*) ' xbin 3 ',i,xbin3(i),xx3(i)
c         enddo
c         xbin4(1)=xx4(1)-(xx4(2)-xx4(1))/20.
c         do I = 1,nxbin1
c            xbin4(i+1) = 2*xx4(i) - xbin4(i)
c        write(6,*) ' xbin 4 ',i,xbin4(i),xx4(i)
c         enddo
c         xbin5(1)=xx5(1)-(xx5(2)-xx5(1))/20.
c         do I = 1,nxbin1
c            xbin5(i+1) = 2*xx5(i) - xbin5(i)
c        write(6,*) ' xbin 5 ',i,xbin5(i),xx5(i)
c         enddo
c         xbin6(1)=xx6(1)-(xx6(2)-xx6(1))/20.
c         do I = 1,nxbin1
c            xbin6(i+1) = 2*xx6(i) - xbin6(i)
c        write(6,*) ' xbin 6 ',i,xbin6(i),xx6(i)
c         enddo
	 
         j=0
         do i=1,9
            if(iq(i).lt.0) then
            else
               j=j+1
c            q2binw(j)=myqbin(i+1)-myqbin(i)
               q2binw(j)=trueqbin(i+1)-trueqbin(i)
            endif
c        write(6,*) ' q2binw ',j,q2binw(j),myqbin(i+1),myqbin(i)
         enddo
	   j=0
         do i=1,8
            if(ix(i).lt.0) then
            else
               j=j+1
               xbinw(j)=truexbin(i+1)-truexbin(i)
            endif
c        write(6,*) ' q2binw ',j,q2binw(j),myqbin(i+1),myqbin(i)
         enddo
*
         delta = 3.
         do i=1,31
            qbin(i) = 10**(delta*(i-1)/30)
            write(6,*) ' qbin ',i,qbin(i)
         enddo
*****************************
*  Make histograms of F2CC
*****************************
*
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
         CALL HBNT(1999,' charm  ',' ')
         CALL HBNAME (1999,'kin',x,'x,y,Q2')
*
         call hbookb( 1001,'f2c Q2=1.5 ',nxbin,xbin,0.)
         call hbookb( 1002,'f2c Q2=3.5 ',nxbin,xbin,0.)
         call hbookb( 1003,'f2c Q2=6.5 ',nxbin,xbin,0.)
         call hbookb( 1004,'f2c Q2=12  ',nxbin,xbin,0.)
         call hbookb( 1005,'f2c Q2=25  ',nxbin,xbin,0.)
         call hbookb( 1006,'f2c Q2=60  ',nxbin,xbin,0.)
         
	 call hbookb( 11001,'f2c Q2=1.5 ',nxbin1,xbin1,0.)
         call hbookb( 11002,'f2c Q2=3.5 ',nxbin1,xbin2,0.)
         call hbookb( 11003,'f2c Q2=6.5 ',nxbin1,xbin3,0.)
         call hbookb( 11004,'f2c Q2=12  ',nxbin1,xbin4,0.)
         call hbookb( 11005,'f2c Q2=25  ',nxbin1,xbin5,0.)
         call hbookb( 11006,'f2c Q2=60  ',nxbin1,xbin6,0.)
	 
	 call hbookb(-1001,'data stat f2c Q2=1.5 ',nxbin1,xbin1,0.)
	 call hbookb(-1002,'data stat f2c Q2=3.5 ',nxbin1,xbin2,0.)
	 call hbookb(-1003,'data stat f2c Q2=6.5 ',nxbin1,xbin3,0.)
         call hbookb(-1004,'data stat f2c Q2=12  ',nxbin1,xbin4,0.)
	 call hbookb(-1005,'data stat f2c Q2=25  ',nxbin1,xbin5,0.)
	 call hbookb(-1006,'data stat f2c Q2=60  ',nxbin1,xbin6,0.)
         
	 call hbookb(-1101,'data tot f2c Q2=1.5 ',nxbin1,xbin1,0.)
         call hbookb(-1102,'data tot f2c Q2=3.5 ',nxbin1,xbin2,0.)
         call hbookb(-1103,'data tot f2c Q2=6.5 ',nxbin1,xbin3,0.)
         call hbookb(-1104,'data tot f2c Q2=12  ',nxbin1,xbin4,0.)
         call hbookb(-1105,'data tot f2c Q2=25  ',nxbin1,xbin5,0.)
         call hbookb(-1106,'data tot f2c Q2=60  ',nxbin1,xbin6,0.)

         Do i =1,nxbin1
            f2_1(i)=yy1(i)
            ef2_1(i)=eyy1(i)
            eft_1(i) = sqrt(eyy1(i)**2 + esy1(i)**2)
         enddo
         Do i =1,nxbin1
            f2_2(i)=yy2(i)
            ef2_2(i)=eyy2(i)
            eft_2(i) = sqrt(eyy2(i)**2 + esy2(i)**2)
         enddo
         Do i =1,nxbin1
            f2_3(i)=yy3(i)
            ef2_3(i)=eyy3(i)
            eft_3(i) = sqrt(eyy3(i)**2 + esy3(i)**2)
         enddo
         Do i =1,nxbin1
            f2_4(i)=yy4(i)
            ef2_4(i)=eyy4(i)
            eft_4(i) = sqrt(eyy4(i)**2 + esy4(i)**2)
         enddo
         Do i =1,nxbin1
            f2_5(i)=yy5(i)
            ef2_5(i)=eyy5(i)
            eft_5(i) = sqrt(eyy5(i)**2 + esy5(i)**2)
         enddo
         Do i =1,nxbin1
            f2_6(i)=yy6(i)
            ef2_6(i)=eyy6(i)
            eft_6(i) = sqrt(eyy6(i)**2 + esy6(i)**2)
         enddo

         write(6,*) ' Q2 = 1.5 '
         write(6,10001)
10001  format('  bin  |     x     |   F2   | ')
         do i=1,nxbin1
            if(f2_1(i).gt.0.0) then
               write(6,10002) i,xx1(i),f2_1(i)
            endif
         enddo
10002  format(i6,' | ',e9.4,' | ',f6.3,' |')
         write(6,*) ' Q2 = 3.5 '
         write(6,10001)
         do i=1,nxbin1
            if(f2_2(i).gt.0.0) then
               write(6,10002) i,xx2(i),f2_2(i)
            endif
         enddo
         write(6,*) ' Q2 = 6.5 '
         write(6,10001)
         do i=1,nxbin1
            if(f2_3(i).gt.0.0) then
               write(6,10002) i,xx3(i),f2_3(i)
            endif
         enddo
         write(6,*) ' Q2 = 12 '
         write(6,10001)
         do i=1,nxbin1
            if(f2_4(i).gt.0.0) then
               write(6,10002) i,xx4(i),f2_4(i)
            endif
         enddo
         write(6,*) ' Q2 = 25 '
         write(6,10001)
         do i=1,nxbin1
            if(f2_5(i).gt.0.0) then
               write(6,10002) i,xx5(i),f2_5(i)
            endif
         enddo
         write(6,*) ' Q2 = 60 '
         write(6,10001)
         do i=1,nxbin1
            if(f2_6(i).gt.0.0) then
               write(6,10002) i,xx6(i),f2_6(i)
            endif
         enddo

         call hpak(-1001,f2_1)
         call hpake(-1001,ef2_1)
         call hpak(-1101,f2_1)
         call hpake(-1101,eft_1)
         call hpak(-1002,f2_2)
         call hpake(-1002,ef2_2)
         call hpak(-1102,f2_2)
         call hpake(-1102,eft_2)
         call hpak(-1003,f2_3)
         call hpake(-1003,ef2_3)
         call hpak(-1103,f2_3)
         call hpake(-1103,eft_3)
         call hpak(-1004,f2_4)
         call hpake(-1004,ef2_4)
         call hpak(-1104,f2_4)
         call hpake(-1104,eft_4)
         call hpak(-1005,f2_5)
         call hpake(-1005,ef2_5)
         call hpak(-1105,f2_5)
         call hpake(-1105,eft_5)
         call hpak(-1006,f2_6)
         call hpake(-1006,ef2_6)
         call hpak(-1106,f2_6)
         call hpake(-1106,eft_6)




c         call hbookb( 1101,'charm bins Q2=1.5 ',nxbin1,xbin1,0.)
c         call hbookb( 1102,'charm bins Q2=3.5 ',nxbin1,xbin2,0.)
c         call hbookb( 1103,'charm bins Q2=6.5 ',nxbin1,xbin3,0.)
c         call hbookb( 1104,'charm bins Q2=12  ',nxbin1,xbin4,0.)
c         call hbookb( 1105,'charm bins Q2=25  ',nxbin1,xbin5,0.)
c         call hbookb( 1106,'charm bins Q2=60  ',nxbin1,xbin6,0.)

         call hbookb(1201,'D* bins visible Q2=1.5',nxbin1,xbin1,0.)
         call hbookb(1202,'D* bins visible Q2=3.5',nxbin1,xbin2,0.)
         call hbookb(1203,'D* bins visible Q2=6.5',nxbin1,xbin3,0.)
         call hbookb(1204,'D* bins visible Q2=12 ',nxbin1,xbin4,0.)
         call hbookb(1205,'D* bins visible Q2=25 ',nxbin1,xbin5,0.)
         call hbookb(1206,'D* bins visible Q2=60 ',nxbin1,xbin6,0.)
         call hbookb(-1201,'D* bins visible Q2=1.5',nxbin1,xbin1,0.)
         call hbookb(-1202,'D* bins visible Q2=3.5',nxbin1,xbin2,0.)
         call hbookb(-1203,'D* bins visible Q2=6.5',nxbin1,xbin3,0.)
         call hbookb(-1204,'D* bins visible Q2=12 ',nxbin1,xbin4,0.)
         call hbookb(-1205,'D* bins visible Q2=25 ',nxbin1,xbin5,0.)
         call hbookb(-1206,'D* bins visible Q2=60 ',nxbin1,xbin6,0.)
         call hpak(-1201,svis1)
         call hpake(-1201,esvis1)
         call hpak(-1202,svis2)
         call hpake(-1202,esvis2)
         call hpak(-1203,svis3)
         call hpake(-1203,esvis3)
         call hpak(-1204,svis4)
         call hpake(-1204,esvis4)
         call hpak(-1205,svis5)
         call hpake(-1205,esvis5)
         call hpak(-1206,svis6)
         call hpake(-1206,esvis6)

         call hbookb(4001,' F2 x=0.00005 ',30,qbin,0.)
         call hbookb(4002,' F2 x=0.0002  ',30,qbin,0.)
         call hbookb(4003,' F2 x=0.0005  ',30,qbin,0.)
         call hbookb(4004,' F2 x=0.0002  ',30,qbin,0.)
         call hbookb(4005,' F2 x=0.00032 ',30,qbin,0.)

         call hbookb(4201,' D* x=0.00005 ',6,myqbin,0.)
         call hbookb(4202,' D* x=0.0002 ',6,myqbin,0.)
         call hbookb(4203,' D* x=0.0005 ',6,myqbin,0.)
         call hbookb(4204,' D* x=0.0002 ',6,myqbin,0.)
         call hbookb(4205,' D* x=0.00032 ',6,myqbin,0.)

         call hbookb( 2001,' dsigma/dq2 ',nq2,dq2,0.)

c         call hbookb( 2002,' dsigma/dx ',nx,dx,0.)
         call hbookb( 2002,' dsigma/dlogx ',nx,dx,0.)
         call hbookb(-2002,'data dsigma/dlogx ',nx,dx,0.)

         call hbookb( 2003,' dsigma/dW ',nW,dW,0.)
         call hbookb(-2003,'data dsigma/dW ',nW,dW,0.)
         call hpak(-2003,sw)
         call hpake(-2003,esw)

         call hbookb( 2004,' dsigma/dxD ',nxd,dxd,0.)
         call hbookb(-2004,'data dsigma/dxD ',nxd,dxd,0.)
         call hpak(-2004,sxd)
         call hpake(-2004,esxd)

         call hbookb( 2005,' dsigma/dpt ',npt,dpt,0.)
         call hbookb(-2005,'data dsigma/dpt ',npt,dpt,0.)
         call hpak(-2005,spt)
         call hpake(-2005,espt)

         call hbookb( 2006,' dsigma/deta ',neta,deta,0.)
         call hbookb(-2006,'data dsigma/deta ',neta,deta,0.)
         call hpak(-2006,seta)
         call hpake(-2006,eseta)

         call hbookb( 3101,' dsigma/dq2 1.5<pt<4 ',n1q2,x1q2,0.)
         call hbookb( 3102,' dsigma/dq2  4<pt<10 ',n1q2,x1q2,0.)
         call hbookb(-3101,'data dsigma/dq2 1.5<pt<4 ',n1q2,x1q2,0.)
         call hbookb(-3102,'data dsigma/dq2  4<pt<10 ',n1q2,x1q2,0.)
         call hpak(-3101,sp1q2)
         call hpake(-3101,esp1q2)
         call hpak(-3102,sp2q2)
         call hpake(-3102,esp2q2)

         call hbookb( 3201,' dsigma/dq2 -1.5<eta<-0.5 ',n2q2,x2q2,0.)
         call hbookb(-3201,'data dsigma/dq2 -1.5<eta<-0.5',n2q2,x2q2,0.)
         call hpak(-3201,seta1q2)
         call hpake(-3201,seta1q2e)
	
         call hbookb( 3202,' dsigma/dq2 -0.5<eta<0.5 ',n2q2,x2q2,0.)
         call hbookb(-3202,'data dsigma/dq2 -0.5<eta<0.5',n2q2,x2q2,0.)
         call hpak(-3202,seta2q2)
         call hpake(-3202,seta2q2e)

         call hbookb( 3203,' dsigma/dq2 0.5<eta<1.5 ',n2q2,x2q2,0.)
         call hbookb(-3203,'data dsigma/dq2 0.5<eta<1.5',n2q2,x2q2,0.)
         call hpak(-3203,seta3q2)
         call hpake(-3203,seta3q2e)

         call hbookb( 3301,' dsigma/deta 1.5<pt<2.5 ',n3eta,x3eta,0.)
         call hbookb(-3301,'data dsigma/deta 1.5<pt<2.5',n3eta,x3eta,0.)
         call hpak(-3301,spt1eta)
         call hpake(-3301,spt1etae)
	
         call hbookb( 3302,' dsigma/deta 2.5<pt<4.0 ',n3eta,x3eta,0.)
         call hbookb(-3302,'data dsigma/deta 2.5<pt<4.0',n3eta,x3eta,0.)
         call hpak(-3302,spt2eta)
         call hpake(-3302,spt2etae)
	
         call hbookb( 3303,' dsigma/deta 4<pt<10.0  ',n3eta,x3eta,0.)
         call hbookb(-3303,'data dsigma/deta 4<pt<10.0 ',n3eta,x3eta,0.)
         call hpak(-3303,spt3eta)
         call hpake(-3303,spt3etae)
	
         call hbookb( 3401,' dsigma/dzd 1.5<pt<2.5 ',n4xd,x4xd,0.)
         call hbookb(-3401,'data dsigma/dzd 1.5<pt<2.5 ',n4xd,x4xd,0.)
         call hpak(-3401,spt1xd)
         call hpake(-3401,spt1xde)

         call hbookb( 3402,' dsigma/dzd 2.5<pt<4.0 ',n4xd,x4xd,0.)
         call hbookb(-3402,'data dsigma/dzd 2.5<pt<4.0 ',n4xd,x4xd,0.)
         call hpak(-3402,spt2xd)
         call hpake(-3402,spt2xde)
	
         call hbookb( 3403,' dsigma/dzd 4<pt<10.0  ',n4xd,x4xd,0.)
         call hbookb(-3403,'data dsigma/dzd 4<pt<10.0  ',n4xd,x4xd,0.)
         call hpak(-3403,spt3xd)
         call hpake(-3403,spt3xde)

	
         call hbookb( 3501,' dsigma/deta 0<zd<0.25 ',n5eta,x5eta,0.)
         call hbookb(-3501,'data dsigma/deta 0<zd<0.25',n5eta,x5eta,0.)
         call hpak(-3501,szd1eta)
         call hpake(-3501,szd1etae)
	
         call hbookb( 3502,' dsigma/deta 0.25<zd<0.5 ',n5eta,x5eta,0.)
         call hbookb(-3502,'data dsigma/deta0.25<zd<0.5',n5eta,x5eta,0.)
         call hpak(-3502,szd2eta)
         call hpake(-3502,szd2etae)
	
         call hbookb( 3503,' dsigma/deta 0.5<zd<1 ',n5eta,x5eta,0.)
         call hbookb(-3503,'data dsigma/deta 0.5<zd<1 ',n5eta,x5eta,0.)
         call hpak(-3503,szd3eta)
         call hpake(-3503,szd3etae)

*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            return
         endif
*
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
         q2=real(hzdiskin(1))
         x=real(hzdiskin(2))
         y=real(hzdiskin(3))
         w2=real(hzdiskin(4))

         charm=.false.
         ldstar=.false.
         ptdcut = 1.5
         rapcut = 1.5
         ylcut=0.05
         yhcut=0.7
         q2lcut=1.
         q2hcut=100.
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
*
         call HZHCMINI(pbeam,pgam,ierr)
         if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            return
         endif
         Do  ihep=1,nhep
            If(Iabs(idhep(ihep)).eq.4) charm=.true.
         enddo
         if(charm) xcharm=xcharm+1.
c calculate JETSET D* braching ratio
         Do ihep=1,nhep
            If(charm) then
               if( idhep(ihep) .eq. 413 ) then
                  xdstar=xdstar+1.
                  goto 12
               endif
            endif
         enddo
   12    continue

         Do 10 ihep=1,nhep
            Do i=1,4
               Ph(i)=PHEP(i,ihep)
               Plab(i,ihep)=PHEP(i,ihep)
               phep(i,ihep)=0.0
            enddo
*
            Do i=1,4
               Phc(i)=PLAB(i,ihep)
            enddo
            call HZHCM(ph,pcm,ierr)
            if (ierr.eq.1) then
               write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
               return
            endif
            do i=1,4
               PHEP(i,ihep)=Pcm(i)
            enddo
            if(y.gt.ylcut.and.y.lt.yhcut.and. q2.gt.q2lcut.and.q2.lt.q2
     +      hcut) then
* Assume JETSET gets the correct branching fraction
               if ( Iabs(idhep(ihep)) .eq. 413 ) then
                  idstar=ihep
* LAB variables
                  call hzgetvar(phc,p,pt,et,th,phdum,phang,rap,err_flag)
                  if ( err_flag.ne.0 ) goto 10
* CMS variables
                  call hzgetvar(pcm,ps,pts,ets,ths,phdum,phangs,raps
     $                 ,err_flag)
                  if ( err_flag.ne.0 ) goto 10
                  if(pt.gt.ptdcut.and.pt.le.15.and.abs(rap).le.rapcut)
     +            then
                     ndstar=ndstar+1
                     ldstar=.true.
                     xd=2.*ps/sqrt(w2)
                     call hfill(2001,q2,0.,wtx)
cc                  call hfill(2002,x,0.,wtx)
                     call hfill(2002,log10(x),0.,wtx)
                     call hfill(2003,sqrt(w2),0.,wtx)
                     call hfill(2004,xd,0.,wtx)
                     call hfill(2005,pt,0.,wtx)
                     call hfill(2006,rap,0.,wtx)
                     if(pt.ge.x1pt(1).and.pt.lt.x1pt(2)) then
                        call hfill(3101,q2,0.,wtx)
                     elseif(pt.ge.x1pt(2).and.pt.lt.x1pt(3)) then
                        call hfill(3102,q2,0.,wtx)
                     endif
                     if(rap.ge.x2eta(1).and.rap.lt.x2eta(2)) then
                        call hfill(3201,q2,0.,wtx)
                     elseif(rap.ge.x2eta(2).and.rap.lt.x2eta(3)) then
                        call hfill(3202,q2,0.,wtx)
                     elseif(rap.ge.x2eta(3).and.rap.lt.x2eta(4)) then
                        call hfill(3203,q2,0.,wtx)
                     endif
                     if(pt.ge.x3pt(1).and.pt.lt.x3pt(2)) then
                        call hfill(3301,rap,0.,wtx)
                        call hfill(3401,xd,0.,wtx)
                     elseif(pt.ge.x3pt(2).and.pt.lt.x3pt(3)) then
                        call hfill(3302,rap,0.,wtx)
                        call hfill(3402,xd,0.,wtx)
                     elseif(pt.ge.x3pt(3).and.pt.lt.x3pt(4)) then
                        call hfill(3303,rap,0.,wtx)
                        call hfill(3403,xd,0.,wtx)
                     endif
                     if(xd.ge.x5xd(1).and.xd.lt.x5xd(2)) then
                        call hfill(3501,rap,0.,wtx)
                     elseif(xd.ge.x5xd(2).and.xd.lt.x5xd(3)) then
                        call hfill(3502,rap,0.,wtx)
                     elseif(xd.ge.x5xd(3).and.xd.lt.x5xd(4)) then
                        call hfill(3503,rap,0.,wtx)
                     endif

                  endif
               endif
            endif
   10    Continue
* fill original PHEP vectors
         do ihep=1,nhep
            Do i=1,4
               PHEP(i,ihep)= Plab(i,ihep)
            enddo
         enddo
         if(charm) then
            call  HFNT (1999)
* first do the exp. bins
            iqbin = -9999
            if(q2.lt.myqbin(1).or.q2.ge.myqbin(7)) then
               goto 111
            endif
            i=0
   50       i=i+1
            if(q2.ge.myqbin(i).and.q2.lt.myqbin(i+1)) then
               iqbin = i
            else
               goto 50
            endif
            if(ldstar) call hfill(1200+iqbin,x,0.,wtx)

*now here the q2 bins for the proper mean values
            iqbin = -9999
            if(q2.lt.trueqbin(1).or.q2.ge.trueqbin(10)) then
               goto 111
            endif
            i=0
   60       i=i+1
            if(q2.ge.trueqbin(i).and.q2.lt.trueqbin(i+1)) then
               iqbin = iq(i)
            else
               goto 60
            endif
            if(iqbin.lt.0) then
               goto 111
            endif
            q2bin(iqbin)=q2bin(iqbin)+q2
            nq2bin(iqbin)=nq2bin(iqbin)+wtx
            call hfill(221,y,0.,wtx)
            call hfill(222,q2,0.,wtx)
* weighting with photon flux
            xw = x*q2b(iqbin)*q2b(iqbin)/(1.-y+y**2/2)
            nall2=nall2+xw
            nev(1000+iqbin)=nev(1000+iqbin)+wtx
c         write(6,*) q2,q2b(iqbin),iqbin,xw,wtx
            call hfill(1000+iqbin,x,0.,xw*wtx)
c            call hfill(1100+iqbin,x,0.,xw*wtx)
c
           nev(11000+iqbin)=nev(11000+iqbin)+wtx
           call hfill(11000+iqbin,x,0.,xw*wtx)
	   
  111       continue
* Now here do it for F2 in bins of x as function of Q2
* first do the exp. bins
c            ixbin = -9999
c            if(x.lt.myxbin(1).or.x.ge.myxbin(7)) then
c           goto 111
c           endif
c            i=0
c   51       i=i+1
c            if(x.ge.myxbin(i).and.x.lt.myxbin(i+1)) then
c               ixbin = i
c            else
c               goto 51
c            endif
c            if(ldstar) call hfill(4200+ixbin,q2,0.,wtx)

*now here the q2 bins for the proper mean values
            ixbin = -9999
            if(x.lt.truexbin(1).or.x.ge.truexbin(9)) then
               goto 112
            endif
            i=0
   61       i=i+1
            if(x.ge.truexbin(i).and.x.lt.truexbin(i+1)) then
               ixbin = ix(i)
            else
               goto 61
            endif
            if(ixbin.lt.0) then
               goto 112
            endif
c            q2bin(iqbin)=q2bin(iqbin)+q2
c            nq2bin(iqbin)=nq2bin(iqbin)+wtx
* weighting with photon flux
c            xw = x*q2b(iqbin)*q2b(iqbin)/(1.-y+y**2/2)
            xw = truex(ixbin)*q2*q2/(1.-y+y**2/2)
            nall3=nall3+xw
c            write(6,*) ixbin,x,ix(i),i
            nev(4000+ixbin)=nev(4000+ixbin)+wtx
            call hfill(4000+ixbin,q2,0.,xw*wtx)

  112       continue
         endif
*
*
*
* determine kin bin of event
*                                             get electron variables
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         if (lp) then
*
*
* Obtain total cross-section
            write(6,*) ' Total Cross section ',xsec,nall
*
            write(6,*)'      '
         endif
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
         brat = xdstar/xcharm
         write(6,*) 'hz',xxxx,'  JETSET D* BR = ',brat,xdstar,xcharm
         write(6,*) 'hz',xxxx,'  correct with new BR=0.233 '
         bratn = 0.233/brat
         bratn = 1.
         dst_xsec= real(ndstar)/real(nall)*xsec*.001*bratn
         lumnb =real(nall)/real(0.001*xsec) * bratn
         write(6,*) 'hz',xxxx,'  D* x section = ',dst_xsec
         write(6,*) 'hz',xxxx,'  nr of D*  = ',ndstar
         write(6,*) 'hz',xxxx,nall,' out of which: D* = ',ndstar

*      normalize the histos
         if(nall2.gt.1) then
* now do the cross section normalisation
            do i1=1,6
               write(6,*)' q2 bins ',i1,q2bin(i1)/nq2bin(i1), q2bin(i1)
     +         ,nq2bin(i1)
               idhisto= 1000 +i1
               idpaw = idhisto
               call hzhinfo(idpaw,int(nev(idhisto)))
               if(nev(idhisto).gt.1) then
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /q2binw(i1)
c                  write(6,*) ' hz01100 ',idhisto,nev(idhisto)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)
c                  write(6,*) ' hz01100 ',idhisto,nev(idhisto)
c                  call hunpak( idpaw,conten)
c                  call hunpke( idpaw,contene)
c                  do i3=1,nxbin
c                     conten(i3)=conten(i3)*fact
c                     contene(i3)=contene(i3)*fact
c                  enddo
c
c                  call hpak( idpaw,conten)
c                  call hpake( idpaw,contene)

c                  call hzchisq(-idhisto-100,idhisto)
               endif
            enddo            
	    
	    do i1=1,6
               write(6,*)' q2 bins ',i1,q2bin(i1)/nq2bin(i1), q2bin(i1)
     +         ,nq2bin(i1)
               idhisto= 11000 +i1
               idpaw = idhisto
               call hzhinfo(idpaw,int(nev(idhisto)))
               if(nev(idhisto).gt.1) then
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /q2binw(i1)
c                  write(6,*) ' hz01100 ',idhisto,nev(idhisto)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)
c                  write(6,*) ' hz01100 ',idhisto,nev(idhisto)
c                  call hunpak( idpaw,conten)
c                  call hunpke( idpaw,contene)
c                  do i3=1,nxbin
c                     conten(i3)=conten(i3)*fact
c                     contene(i3)=contene(i3)*fact
c                  enddo
c
c                  call hpak( idpaw,conten)
c                  call hpake( idpaw,contene)

c                  call hzchisq(-idhisto-100,idhisto)
               endif
            enddo

* now do the Q2 at fixed x
            do i1=1,5
               write(6,*)' x bins ',i1,truex(i1),xbinw(i1)
               idhisto= 4000 +i1
               idpaw = idhisto
               call hzhinfo(idpaw,int(nev(idhisto)))
               if(nev(idhisto).gt.1) then
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /xbinw(i1)
c                  write(6,*) ' hz01100 ',idhisto,nev(idhisto)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)
c                  write(6,*) ' hz01100 ',idhisto,nev(idhisto)
c                  call hunpak( idpaw,conten2)
c                  call hunpke( idpaw,contene2)
c                  do i3=1,30
c                     conten2(i3)=conten2(i3)*fact
c                     contene2(i3)=contene2(i3)*fact
c                  enddo
c
c                  call hpak( idpaw,conten2)
c                  call hpake( idpaw,contene2)

c                  call hzchisq(-idhisto-100,idhisto)
               endif
            enddo

            do i=1,6
               idhisto=1200+i
               call hopera(idhisto,'+E',idhisto,idhisto,1./lumnb,0.)
            enddo
            do i=1,5
               idhisto=4200+i
               call hopera(idhisto,'+E',idhisto,idhisto,1./lumnb,0.)
            enddo

            call hzhinrm( 2001, 0, 1., 1 )
            call hopera(2001,'+E',2001,2001,1./lumnb,0.)
            call hzhinrm( 2002, 0, 1., 1 )
            call hopera(2002,'+E',2002,2002,1./lumnb,0.)
            call hzhinrm( 2003, 0, 1., 1 )
            call hopera(2003,'+E',2003,2003,1./lumnb,0.)
            call hzhinrm( 2004, 0, 1., 1 )
            call hopera(2004,'+E',2004,2004,1./lumnb,0.)
            call hzhinrm( 2005, 0, 1., 1 )
            call hopera(2005,'+E',2005,2005,1./lumnb,0.)
            call hzhinrm( 2006, 0, 1., 1 )
            call hopera(2006,'+E',2006,2006,1./lumnb,0.)



            xlunorm = 1./lumnb/(x1pt(2)-x1pt(1))
            call hzhinrm( 3101, 0, 1., 1 )
            call hopera(3101,'+E',3101,3101,xlunorm,0.)
            xlunorm = 1./lumnb/(x1pt(3)-x1pt(2))
            call hzhinrm( 3102, 0, 1., 1 )
            call hopera(3102,'+E',3102,3102,xlunorm,0.)
            do i=1,3
               call hzhinrm( 3200+i, 0, 1., 1 )
               xlunorm = 1./lumnb/(x2eta(i+1)-x2eta(i))
               call hopera(3200+i,'+E',3200+i,3200+i,xlunorm,0.)
               call hzhinrm( 3300+i, 0, 1., 1 )
               xlunorm = 1./lumnb/(x3pt(i+1)-x3pt(i))
               call hopera(3300+i,'+E',3300+i,3300+i,xlunorm,0.)
               call hzhinrm( 3400+i, 0, 1., 1 )
               xlunorm = 1./lumnb/(x4pt(i+1)-x4pt(i))
               call hopera(3400+i,'+E',3400+i,3400+i,xlunorm,0.)
               call hzhinrm( 3500+i, 0, 1., 1 )
               xlunorm = 1./lumnb/(x5xd(i+1)-x5xd(i))
               call hopera(3500+i,'+E',3500+i,3500+i,xlunorm,0.)
            enddo
         endif
*
*
*
      endif
      RETURN
      END
