
      subroutine hz96039(IFLAG)
***********************************************
* F2 data H1
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact

      Integer iqbin,i1,i3,idhisto,idpaw
      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=2000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2
      Real xw
      Data nall/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real x,y,w2,q2

      double precision dx,dq
      real f2pdf
      DOUBLE PRECISION XXX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20)
      CHARACTER*20 PARM(20)
      Integer npdf
      DATA NPDF/0/,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU/9*0.D0/
      LOGICAL PDFFIRST
      COMMON /W50516/PDFFIRST
*
*
* F2 data
*
      Integer nf2
      Parameter (nf2=9)
      Real xx1(5),yy1(5)
      Real xx2(6),yy2(6)
      Real xx3(nf2),yy3(nf2)
      Real xx4(nf2),yy4(nf2)
      Real xx5(nf2),yy5(nf2)
      Real xx6(nf2),yy6(nf2)
      Real xx7(nf2),yy7(nf2)
      Real xx8(nf2),yy8(nf2)
      Real xx9(nf2),yy9(nf2)
      Real xx10(nf2),yy10(nf2)
      Real xx11(nf2),yy11(nf2)
      Real xx12(nf2),yy12(nf2)
      Real xx13(nf2),yy13(nf2)
      Real xx14(nf2),yy14(nf2)
      Integer nxbin
	Parameter (nxbin=26)
      Integer nxbin1
	Parameter (nxbin1=6)
      Integer nxbin2
	Parameter (nxbin2=8)
      Integer nxbin3
      Parameter (nxbin3=16)
      Integer nxbin4
      Parameter (nxbin4=16)
      Integer nxbin5
      Parameter (nxbin5=16)
      Integer nxbin6
      Parameter (nxbin6=23)
      Real f2_1(nxbin1),f2_2(nxbin2),f2_3(nxbin3)
      Real ef2_1(nxbin1),ef2_2(nxbin2),ef2_3(nxbin3)
      Real eft_1(nxbin1),eft_2(nxbin2),eft_3(nxbin3)
      Real f2_4(nxbin4),f2_5(nxbin5),f2_6(nxbin6)
      Real ef2_4(nxbin4),ef2_5(nxbin5),ef2_6(nxbin6)
      Real eft_4(nxbin4),eft_5(nxbin5),eft_6(nxbin6)
      Real f2_7(nxbin6),f2_8(nxbin6),f2_9(nxbin6)
      Real ef2_7(nxbin6),ef2_8(nxbin6),ef2_9(nxbin6)
      Real eft_7(nxbin6),eft_8(nxbin6),eft_9(nxbin6)
      Real f2_10(nxbin6),f2_11(nxbin6),f2_12(nxbin6)
      Real ef2_10(nxbin6),ef2_11(nxbin6),ef2_12(nxbin6)
      Real eft_10(nxbin6),eft_11(nxbin6),eft_12(nxbin6)
      Real f2_13(nxbin6),f2_14(nxbin6),f2_15(nxbin6)
      Real ef2_13(nxbin6),ef2_14(nxbin6),ef2_15(nxbin6)
      Real eft_13(nxbin6),eft_14(nxbin6),eft_15(nxbin6)
	
      Real eyy1(5),eyy2(6),eyy3(nf2)
      Real eyy4(nf2),eyy5(nf2),eyy6(nf2)
      Real eyy7(nf2),eyy8(nf2),eyy9(nf2)
      Real eyy10(nf2),eyy11(nf2),eyy12(nf2)
      Real eyy13(nf2),eyy14(nf2),eyy15(nf2)
      Real esy1(5),esy2(6),esy3(nf2)
      Real esy4(nf2),esy5(nf2),esy6(nf2)
      Real esy7(nf2),esy8(nf2),esy9(nf2)
      Real esy10(nf2),esy11(nf2),esy12(nf2)
      Real esy13(nf2),esy14(nf2),esy15(nf2)
*
* f2 data from H1 NPB 470 (1996) 3 DESY 96-039
*    f2 Q2=1.5 (bin 1)
      Data xx1/0.00003, 0.00025, 0.00063, 0.00158, 0.00398/
      Data yy1/ 0.969, 0.540, 0.458, 0.365, 0.381/
      Data eyy1/0.176, 0.055, 0.050, 0.045, 0.070/
      Data esy1/0.187, 0.104, 0.101, 0.095, 0.087/

*    f2 Q2=2.5 (bin 2)
      Data xx2/0.00008, 0.00013, 0.00025, 0.00063, 0.00158, 0.00398/
      Data yy2/ 0.885, 0.874, 0.622, 0.621, 0.466, 0.402/
      Data eyy2/0.052, 0.079, 0.037, 0.039, 0.033, 0.039/
      Data esy2/0.065, 0.127, 0.119, 0.093, 0.072, 0.062/
*    f2 Q2=3.5 (bin 3)
      Data xx3/0.00008,0.00013, 0.00020, 0.00032, 0.0005 ,
     +         0.0008, 0.00130, 0.00250, 0.00398/
      Data yy3/ 1.036, 1.026, 0.934, 0.854, 0.716,
     +          0.712, 0.778, 0.621, 0.458/
      Data eyy3/0.053, 0.045, 0.041, 0.046, 0.041,
     +          0.049, 0.058, 0.043, 0.046/
      Data esy3/0.092, 0.067, 0.075, 0.093, 0.119,
     +          0.126, 0.137, 0.157, 0.075/
*    f2 Q2=5.0 (bin 4)
      Data xx4/0.00013, 0.00020, 0.00032, 0.0005 ,
     +         0.0008, 0.00130, 0.00200, 0.00400,0.008/
      Data yy4/ 1.106, 1.033, 0.907, 0.839, 0.769,
     +          0.630, 0.540, 0.500, 0.0/
      Data eyy4/0.049, 0.044, 0.039, 0.039, 0.037,
     +          0.034, 0.033, 0.029, 0.0/
      Data esy4/0.074, 0.069, 0.066, 0.076, 0.063,
     +          0.050, 0.043, 0.086, 0.0/

*    f2 Q2=6.5 (bin 5)
      Data xx5/0.00013, 0.00020, 0.00032, 0.0005 ,
     +         0.0008, 0.00130, 0.00250, 0.00630 ,0.008/
      Data yy5/ 1.292, 1.101, 0.963, 0.926, 0.848,
     +          0.759, 0.667, 0.504, 0.0/
      Data eyy5/0.085, 0.052, 0.045, 0.044, 0.038,
     +          0.039, 0.029, 0.029, 0.0/
      Data esy5/0.127, 0.072, 0.068, 0.088, 0.076,
     +          0.068, 0.054, 0.084, 0.0/

*    f2 Q2=8.5 (bin 6)
      Data xx6/0.00020, 0.00032, 0.0005 ,
     +         0.0008, 0.00130, 0.00200, 0.00320,0.005,0.008/
      Data yy6/ 1.215, 1.089, 1.033, 0.923, 0.811,
     +          0.770, 0.562, 0.648, 0.564/
      Data eyy6/0.050, 0.038, 0.034, 0.031, 0.030,
     +          0.034, 0.028, 0.033, 0.032/
      Data esy6/0.062, 0.048, 0.062, 0.038, 0.047,
     +          0.049, 0.043, 0.051, 0.049/

*    f2 Q2=12 (bin 7)
      Data xx7/0.00032,0.0005, 0.0008, 0.0013, 0.002 , 0.0032, 0.005,
     +0.008, 0.013/
      Data yy7/ 1.276, 1.168 ,1.067 ,0.942 ,0.866 ,0.749 ,0.685,
     +0.618, 0.531/
      Data eyy7/0.020, 0.016, 0.015, 0.015, 0.016, 0.016, 0.016,
     +0.016, 0.017/
      Data esy7/0.055, 0.056, 0.061, 0.039, 0.057, 0.055, 0.061,
     +0.057, 0.049/
*    f2 Q2=15 (bin 8)
      Data xx8/0.00032,0.0005, 0.0008, 0.0013, 0.002 , 0.0032, 0.005,
     +0.008, 0.013/
      Data yy8/ 1.426, 1.280 , 1.110 , 1.008 , 0.895 , 0.773 , 0.677,
     +0.634, 0.547/
      Data eyy8/0.030, 0.020, 0.018, 0.016, 0.015, 0.014, 0.014,
     +0.014, 0.013/
      Data esy8/0.064, 0.050, 0.057, 0.033, 0.046, 0.036, 0.035,
     +0.031, 0.027/
*    f2 Q2=20 (bin 9)
      Data xx9/0.0005, 0.0008, 0.0013, 0.002 , 0.0032, 0.005,
     +0.008, 0.013, 0.02/
      Data yy9/ 1.407, 1.210 , 1.061 , 0.945 , 0.861 , 0.761 , 0.693,
     +0.567, 0.487/
      Data eyy9/0.026, 0.022, 0.020, 0.018, 0.017, 0.017, 0.016,
     +0.015, 0.015/
      Data esy9/0.054, 0.050, 0.055, 0.042, 0.038, 0.028, 0.035,
     +0.024, 0.025/
*    f2 Q2=25 (bin 10)
      Data xx10/0.0005, 0.0008, 0.0013, 0.002 , 0.0032, 0.0050, 0.008,
     +0.0130, 0.02/
      Data yy10/1.546 , 1.330 , 1.151 , 1.019 , 0.872 , 0.768 , 0.683,
     +0.585 ,0.548/
      Data eyy10/0.047, 0.028, 0.024, 0.022, 0.020, 0.019, 0.018,
     +0.017, 0.017/
      Data esy10/0.058, 0.051, 0.047, 0.035, 0.034, 0.034, 0.031,
     +0.028, 0.037/
*    f2 Q2=35 (bin 11)
      Data xx11/0.0008, 0.0013, 0.002 , 0.0032, 0.0050, 0.008,
     +0.0130, 0.02, 0.032/
      Data yy11/1.442 , 1.308 , 1.116 , 0.928 , 0.832 , 0.739 , 0.600,
     +0.508 ,0.452/
      Data eyy11/0.038, 0.032, 0.027, 0.024, 0.023, 0.022, 0.019,
     +0.019, 0.019/
      Data esy11/0.051, 0.052, 0.052, 0.038, 0.040, 0.035, 0.025,
     +0.019, 0.026/
*    f2 Q2=45 (bin 12)
      Data xx12/0.0013, 0.0020, 0.0032, 0.005 , 0.0080, 0.0130, 0.020,
     +0.0320,0.05/
      Data yy12/1.3050, 1.2250, 1.1050, 0.912 , 0.7430, 0.6860, 0.599,
     +0.5050,0.4110/
      Data eyy12/0.038, 0.034, 0.032, 0.028, 0.025, 0.024, 0.022,
     +0.021, 0.022/
      Data esy12/0.048, 0.049, 0.058, 0.033, 0.029, 0.031, 0.027,
     +0.023, 0.028/
*    f2 Q2=60 (bin 13)
      Data xx13/0.0020, 0.0032, 0.005 , 0.0080, 0.0130, 0.020,
     +0.0320,0.05,0.08/
      Data yy13/1.213, 1.079, 0.937, 0.830 , 0.701, 0.639, 0.586,
     +0.492,0.432/
      Data eyy13/0.042, 0.037, 0.033, 0.031, 0.028, 0.027, 0.026,
     +0.025,0.027/
      Data esy13/0.048, 0.045, 0.043, 0.046, 0.029, 0.025, 0.028,
     +0.023,0.023/
*    f2 Q2=90 (bin 14)
      Data xx14/0.0032, 0.005 , 0.0080, 0.0130, 0.020,
     +0.0320,0.05,0.08,0.130/
      Data yy14/1.103, 0.997, 0.908, 0.726 , 0.650, 0.587, 0.481,
     +0.0,0.0/
      Data eyy14/0.052, 0.045, 0.041, 0.035, 0.033, 0.030, 0.027,
     +0.0,0.0/
      Data esy14/0.048, 0.047, 0.056, 0.040, 0.031, 0.034, 0.019,
     +0.0,0.0/

      Real myqbin(16)
c      Data myqbin/1.,2.,3.,4.,6.,7.,10.,14.,16.,24.,28.,40.,50.,70.,
c     +            110./
c      Data myqbin/1.,2.,3.,4.,6.,7.,10.,14.,16.,22.,28.,40.,50.,70.,
c     +110./
       Data myqbin/1.0,2.2,2.85,4.3,5.9,7.2,10.1,11.5,12.5,18.3,
     + 22.,29.,42.,50.,73.,115./
      Real q2b(14)
      data q2b/1.5,2.5,3.5,5.,6.5,8.5,12.,15.,20.,25.,35.,45.,60.,90./
      Real q2binw(15)
      Real xcenter(nxbin+2),xbin(nxbin+1)
      Data xcenter/0.0000032,0.000005, 0.000008, 0.000013, 0.00002,
     +             0.000032, 0.00005,  0.00008,  0.00013,  0.0002,
     +             0.00032,  0.0005,   0.0008,   0.0013,   0.002,
     +             0.0025, 0.0032,
     +             0.004,   0.005, 0.0063,   0.008,    0.013,    0.02,
     +             0.032,    0.05,     0.08, 0.13, 0.2/
      Real xcent1(nxbin1+2),xbin1(nxbin1+1)
	Data xcent1/0.00001,0.00003,0.00025,0.00063,
     +	0.00158,0.00398,0.008,0.013/
      Real xcent2(nxbin2+2),xbin2(nxbin2+1)
	Data xcent2/0.00001,0.00003,0.00008,0.00013,0.00025,0.00063,
     +	0.00158,0.00398,0.008,0.013/
      Real xcent3(nxbin3+2),xbin3(nxbin3+1)
      Data xcent3/0.0000032,0.000005, 0.000008, 0.000013, 0.00002,
     +             0.000032, 0.00005,  0.00008,  0.00013,  0.0002,
     +             0.00032,  0.0005,   0.0008,   0.0013,   0.0025,
     +             0.00398,    0.005,    0.008/
      Real xcent4(nxbin4+2),xbin4(nxbin4+1)
      Data xcent4/0.0000032,0.000005, 0.000008, 0.000013, 0.00002,
     +             0.000032, 0.00005,  0.00008,  0.00013,  0.0002,
     +             0.00032,  0.0005,   0.0008,   0.0013,   0.0020,
     +             0.004,    0.005,    0.008/
      Real xcent5(nxbin5+2),xbin5(nxbin5+1)
      Data xcent5/0.0000032,0.000005, 0.000008, 0.000013, 0.00002,
     +             0.000032, 0.00005,  0.00008,  0.00013,  0.0002,
     +             0.00032,  0.0005,   0.0008,   0.0013,   0.0025,
     +             0.0063,   0.013,    0.02/
      Real xcent6(nxbin6+2),xbin6(nxbin6+1)
      Data xcent6/0.0000032,0.000005, 0.000008, 0.000013, 0.00002,
     +             0.000032, 0.00005,  0.00008,  0.00013,  0.0002,
     +             0.00032,  0.0005,   0.0008,   0.0013,   0.002,
     +             0.0032,   0.005,    0.008,    0.013,    0.02,
     +             0.032,    0.05,     0.08,     0.13,     0.2/
      Integer nktbin
	Parameter (nktbin=7)
	Real xktbin(nktbin+1)
	Data xktbin/0.0001,0.5,1.,1.4,4.,10.,25.,1000./
      Real conten(nxbin),contene(nxbin)
	
	Real q2bin(14)
	Real nq2bin(14)

      real sigm,phip,beta,t,x_pom,xmas,ymas
c      common/cwnco1/x,y,Q2,x_pom,beta,t,phip,xmas,ymas,sigm
      Real xkt1,xkt2,x1,x2
      Integer igl1,igl2

      save Qpi, qqradp, q2binw, nall, nall2, nev, 
     &     nq2bin, q2bin

*
****************************************************************************
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'96039'/
*
	Double precision chi
	Integer ndf
	Double precision chit
	Integer ndft
	Common/fit/chit,ndft
	double precision xsim,ykt
	common/hzbval/xsim,ykt
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         write(6,*)' hz96039 my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*
         do I = 1,nxbin+1
            xbin(i) = xcenter(i) + (xcenter(i+1)-xcenter(i))/2.
         enddo
         xbin1(1)=xcent1(1)-(xcent1(2)-xcent1(1))/20.
         do I = 1,nxbin1
            xbin1(i+1) = 2*xcent1(i) - xbin1(i)
         enddo
         xbin2(1)=xcent2(1)-(xcent2(2)-xcent2(1))/20.
         do I = 1,nxbin2
            xbin2(i+1) = 2*xcent2(i) - xbin2(i)
         enddo
         xbin3(1)=xcent3(1)-(xcent3(2)-xcent3(1))/20.
         do I = 1,nxbin3
            xbin3(i+1) = 2*xcent3(i) - xbin3(i)
         enddo
         xbin4(1)=xcent4(1)-(xcent4(2)-xcent4(1))/20.
         do I = 1,nxbin4
            xbin4(i+1) = 2*xcent4(i) - xbin4(i)
         enddo
         xbin5(1)=xcent5(1)-(xcent5(2)-xcent5(1))/20.
         do I = 1,nxbin5
            xbin5(i+1) = 2*xcent5(i) - xbin5(i)
         enddo
         xbin6(1)=xcent6(1)-(xcent6(2)-xcent6(1))/20.
         do I = 1,nxbin6
            xbin6(i+1) = 2*xcent6(i) - xbin6(i)
         enddo

         J=0
         do i=1,15
	      if(i.ne.7) then
	      j=j+1
            q2binw(j)=myqbin(i+1)-myqbin(i)
c		write(6,*) ' q2binw ',j,q2binw(j),myqbin(i+1),myqbin(i)
		endif
         enddo
*****************************
*  Make histograms of F2 , F2CC and F2CC/F2 for pure PDF function
*****************************
*
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
*
         call hbookb( 1001,'f2 Q2=1.5 ',nxbin1,xbin1,0.)
         call hbookb( 1002,'f2 Q2=2.5 ',nxbin2,xbin2,0.)
         call hbookb( 1003,'f2 Q2=3.5 ',nxbin3,xbin3,0.)
         call hbookb( 1004,'f2 Q2=5.0 ',nxbin4,xbin4,0.)
         call hbookb( 1005,'f2 Q2=6.5 ',nxbin5,xbin5,0.)
         call hbookb( 1006,'f2 Q2=8.5 ',nxbin6,xbin6,0.)
         call hbookb( 1007,'f2 Q2=12. ',nxbin6,xbin6,0.)
         call hbookb( 1008,'f2 Q2=15. ',nxbin6,xbin6,0.)
         call hbookb( 1009,'f2 Q2=20. ',nxbin6,xbin6,0.)
         call hbookb( 1010,'f2 Q2=25. ',nxbin6,xbin6,0.)
         call hbookb( 1011,'f2 Q2=35. ',nxbin6,xbin6,0.)
         call hbookb( 1012,'f2 Q2=45. ',nxbin6,xbin6,0.)
         call hbookb( 1013,'f2 Q2=60. ',nxbin6,xbin6,0.)
         call hbookb( 1014,'f2 Q2=90. ',nxbin6,xbin6,0.)

	   do I=1001,1014
	   call hbarx(i)
	   enddo
	   
	   
         call hbookb( 2001,'f2 Q2=1.5 pdf',nxbin,xbin,0.)
         call hbookb( 2002,'f2 Q2=2.5 pdf ',nxbin,xbin,0.)
         call hbookb( 2003,'f2 Q2=3.5 pdf ',nxbin,xbin,0.)
         call hbookb( 2004,'f2 Q2=5.0 pdf ',nxbin,xbin,0.)
         call hbookb( 2005,'f2 Q2=6.5 pdf ',nxbin,xbin,0.)
         call hbookb( 2006,'f2 Q2=8.5 pdf ',nxbin,xbin,0.)
         call hbookb( 2007,'f2 Q2=12. pdf ',nxbin,xbin,0.)
         call hbookb( 2008,'f2 Q2=15. pdf ',nxbin,xbin,0.)
         call hbookb( 2009,'f2 Q2=20. pdf ',nxbin,xbin,0.)
         call hbookb( 2010,'f2 Q2=25. pdf ',nxbin,xbin,0.)
         call hbookb( 2011,'f2 Q2=35. pdf ',nxbin,xbin,0.)
         call hbookb( 2012,'f2 Q2=45. pdf ',nxbin,xbin,0.)
         call hbookb( 2013,'f2 Q2=60. pdf ',nxbin,xbin,0.)
         call hbookb( 2014,'f2 Q2=90. pdf ',nxbin,xbin,0.)
         call hbookb( -1001,'f2 Q2=1.5 data stat',nxbin1,xbin1,0.)
         call hbookb( -1101,'f2 Q2=1.5 data tot',nxbin1,xbin1,0.)
         call hbookb( -1002,'f2 Q2=2.5 data stat',nxbin2,xbin2,0.)
         call hbookb( -1102,'f2 Q2=2.5 data tot',nxbin2,xbin2,0.)
         call hbookb( -1003,'f2 Q2=3.5 data stat',nxbin3,xbin3,0.)
         call hbookb( -1103,'f2 Q2=3.5 data tot',nxbin3,xbin3,0.)
         call hbookb( -1004,'f2 Q2=5.0 data stat',nxbin4,xbin4,0.)
         call hbookb( -1104,'f2 Q2=5.0 data tot',nxbin4,xbin4,0.)
         call hbookb( -1005,'f2 Q2=6.5 data stat',nxbin5,xbin5,0.)
         call hbookb( -1105,'f2 Q2=6.5 data tot',nxbin5,xbin5,0.)
         call hbookb( -1006,'f2 Q2=8.5 data stat',nxbin6,xbin6,0.)
         call hbookb( -1106,'f2 Q2=8.5 data tot',nxbin6,xbin6,0.)
         call hbookb( -1007,'f2 Q2=12. data stat',nxbin6,xbin6,0.)
         call hbookb( -1107,'f2 Q2=12. data tot',nxbin6,xbin6,0.)
         call hbookb( -1008,'f2 Q2=15. data stat',nxbin6,xbin6,0.)
         call hbookb( -1108,'f2 Q2=15. data tot',nxbin6,xbin6,0.)
         call hbookb( -1009,'f2 Q2=20. data stat',nxbin6,xbin6,0.)
         call hbookb( -1109,'f2 Q2=20. data tot',nxbin6,xbin6,0.)
         call hbookb( -1010,'f2 Q2=25. data stat',nxbin6,xbin6,0.)
         call hbookb( -1110,'f2 Q2=25. data tot',nxbin6,xbin6,0.)
         call hbookb( -1011,'f2 Q2=35. data stat',nxbin6,xbin6,0.)
         call hbookb( -1111,'f2 Q2=35. data tot',nxbin6,xbin6,0.)
         call hbookb( -1012,'f2 Q2=45. data stat',nxbin6,xbin6,0.)
         call hbookb( -1112,'f2 Q2=45. data tot',nxbin6,xbin6,0.)
         call hbookb( -1013,'f2 Q2=60. data stat',nxbin6,xbin6,0.)
         call hbookb( -1113,'f2 Q2=60. data tot',nxbin6,xbin6,0.)
         call hbookb( -1014,'f2 Q2=90. data stat',nxbin6,xbin6,0.)
         call hbookb( -1114,'f2 Q2=90. data tot',nxbin6,xbin6,0.)

        j=1
         Do i =1,nxbin1
            f2_1(i)=0.
            if(j.le.5) then
               if(xcent1(i).eq.xx1(j)) then
                  f2_1(i)=yy1(j)
                  ef2_1(i)=eyy1(j)
                  eft_1(i) = sqrt(eyy1(j)**2 + esy1(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin2
            f2_2(i)=0.
            if(j.le.6) then
               if(xcent2(i).eq.xx2(j)) then
                  f2_2(i)=yy2(j)
                  ef2_2(i)=eyy2(j)
                  eft_2(i) = sqrt(eyy2(j)**2 + esy2(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin3
            f2_3(i)=0.
            if(j.le.nf2) then
               if(xcent3(i).eq.xx3(j)) then
                  f2_3(i)=yy3(j)
                  ef2_3(i)=eyy3(j)
                  eft_3(i) = sqrt(eyy3(j)**2 + esy3(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin4
            f2_4(i)=0.
            if(j.le.nf2) then
               if(xcent4(i).eq.xx4(j)) then
                  f2_4(i)=yy4(j)
                  ef2_4(i)=eyy4(j)
                  eft_4(i) = sqrt(eyy4(j)**2 + esy4(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin5
            f2_5(i)=0.
            if(j.le.nf2) then
               if(xcent5(i).eq.xx5(j)) then
                  f2_5(i)=yy5(j)
                  ef2_5(i)=eyy5(j)
                  eft_5(i) = sqrt(eyy5(j)**2 + esy5(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_6(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx6(j)) then
                  f2_6(i)=yy6(j)
                  ef2_6(i)=eyy6(j)
                  eft_6(i) = sqrt(eyy6(j)**2 + esy6(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_7(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx7(j)) then
                  f2_7(i)=yy7(j)
                  ef2_7(i)=eyy7(j)
                  eft_7(i) = sqrt(eyy7(j)**2 + esy7(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_8(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx8(j)) then
                  f2_8(i)=yy8(j)
                  ef2_8(i)=eyy8(j)
                  eft_8(i) = sqrt(eyy8(j)**2 + esy8(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_9(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx9(j)) then
                  f2_9(i)=yy9(j)
                  ef2_9(i)=eyy9(j)
                  eft_9(i) = sqrt(eyy9(j)**2 + esy9(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_10(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx10(j)) then
                  f2_10(i)=yy10(j)
                  ef2_10(i)=eyy10(j)
                  eft_10(i) = sqrt(eyy10(j)**2 + esy10(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_11(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx11(j)) then
                  f2_11(i)=yy11(j)
                  ef2_11(i)=eyy11(j)
                  eft_11(i) = sqrt(eyy11(j)**2 + esy11(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_12(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx12(j)) then
                  f2_12(i)=yy12(j)
                  ef2_12(i)=eyy12(j)
                  eft_12(i) = sqrt(eyy12(j)**2 + esy12(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_13(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx13(j)) then
                  f2_13(i)=yy13(j)
                  ef2_13(i)=eyy13(j)
                  eft_13(i) = sqrt(eyy13(j)**2 + esy13(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin6
            f2_14(i)=0.
            if(j.le.nf2) then
               if(xcent6(i).eq.xx14(j)) then
                  f2_14(i)=yy14(j)
                  ef2_14(i)=eyy14(j)
                  eft_14(i) = sqrt(eyy14(j)**2 + esy14(j)**2)
                  j=j+1
               endif
            endif
         enddo


c         write(6,*) ' Q2 = 1.5 '
c         write(6,10001)
c10001  format('  bin  |     x     |   F2   | ')
c         do i=1,nxbin1
c            if(f2_1(i).gt.0.0) then
c               write(6,10002) i,xcent1(i),f2_1(i)
c		   write(6,*) eft_1(i),xbin1(i),xbin1(i+1)
c            endif
c         enddo
c10002  format(i6,' | ',e9.4,' | ',f6.3,' |')
c         write(6,*) ' Q2 = 2.5 '
c         write(6,10001)
c         do i=1,nxbin2
c            if(f2_2(i).gt.0.0) then
c               write(6,10002) i,xcent2(i),f2_2(i)
c		   write(6,*) eft_2(i),xbin2(i),xbin2(i+1)
c            endif
c         enddo
c         write(6,*) ' Q2 = 3.5 '
c         write(6,10001)
c         do i=1,nxbin3
c            if(f2_3(i).gt.0.0) then
c               write(6,10002) i,xcent3(i),f2_3(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 5 '
c         write(6,10001)
c         do i=1,nxbin4
c            if(f2_4(i).gt.0.0) then
c               write(6,10002) i,xcent4(i),f2_4(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 6.5 '
c         write(6,10001)
c         do i=1,nxbin5
c            if(f2_5(i).gt.0.0) then
c               write(6,10002) i,xcent5(i),f2_5(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 8.5 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_6(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_6(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 12 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_7(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_7(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 15 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_8(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_8(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 20 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_9(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_9(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 25 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_10(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_10(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 35 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_11(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_11(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 45 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_12(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_12(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 60 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_13(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_13(i)
c            endif
c         enddo
c         write(6,*) ' Q2 = 90 '
c         write(6,10001)
c         do i=1,nxbin6
c            if(f2_14(i).gt.0.0) then
c               write(6,10002) i,xcent6(i),f2_14(i)
c            endif
c         enddo

         call hpak(-1001,f2_1)
         call hpake(-1001,ef2_1)
         call hpak(-1101,f2_1)
         call hpake(-1101,eft_1)
         call hpak(-1002,f2_2)
         call hpake(-1002,ef2_2)
         call hpak(-1102,f2_2)
         call hpake(-1102,eft_2)
         call hpak(-1003,f2_3)
         call hpake(-1003,ef2_3)
         call hpak(-1103,f2_3)
         call hpake(-1103,eft_3)
         call hpak(-1004,f2_4)
         call hpake(-1004,ef2_4)
         call hpak(-1104,f2_4)
         call hpake(-1104,eft_4)
         call hpak(-1005,f2_5)
         call hpake(-1005,ef2_5)
         call hpak(-1105,f2_5)
         call hpake(-1105,eft_5)
         call hpak(-1006,f2_6)
         call hpake(-1006,ef2_6)
         call hpak(-1106,f2_6)
         call hpake(-1106,eft_6)
         call hpak(-1007,f2_7)
         call hpake(-1007,ef2_7)
         call hpak(-1107,f2_7)
         call hpake(-1107,eft_7)
         call hpak(-1008,f2_8)
         call hpake(-1008,ef2_8)
         call hpak(-1108,f2_8)
         call hpake(-1108,eft_8)
         call hpak(-1009,f2_9)
         call hpake(-1009,ef2_9)
         call hpak(-1109,f2_9)
         call hpake(-1109,eft_9)
         call hpak(-1010,f2_10)
         call hpake(-1010,ef2_10)
         call hpak(-1110,f2_10)
         call hpake(-1110,eft_10)
         call hpak(-1011,f2_11)
         call hpake(-1011,ef2_11)
         call hpak(-1111,f2_11)
         call hpake(-1111,eft_11)
         call hpak(-1012,f2_12)
         call hpake(-1012,ef2_12)
         call hpak(-1112,f2_12)
         call hpake(-1112,eft_12)
         call hpak(-1013,f2_13)
         call hpake(-1013,ef2_13)
         call hpak(-1113,f2_13)
         call hpake(-1113,eft_13)
         call hpak(-1014,f2_14)
         call hpake(-1014,ef2_14)
         call hpak(-1114,f2_14)
         call hpake(-1114,eft_14)
	   
	   nall = 0
	   nall2 = 0
	   Do I=1,maxhi
	   nev(i) =0
	   enddo
	   Do I=1,14
	   q2bin(i) = 0
	   nq2bin(i) = 0
	   enddo
*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         ierr=HZIBEAM(ibeam,idum)
c          write(6,*) 'hz96039 ',ibeam,idum
          if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
c            return
         endif
*
         q2=real(hzdiskin(1))
         x=real(hzdiskin(2))
         y=real(hzdiskin(3))
         w2=real(hzdiskin(4))
         iqbin = -9999
         
c         write(6,*) ' dis kin ',q2,x,y
         
         
         if(q2.lt.myqbin(1).or.q2.ge.myqbin(16)) return
         i=0
   50    i=i+1
         if(q2.ge.myqbin(i).and.q2.lt.myqbin(i+1)) then
            iqbin = i
         else
            goto 50
         endif
	   if(iqbin.eq.7) return
	   if(iqbin.gt.7) iqbin=i-1
	   q2bin(iqbin)=q2bin(iqbin)+q2
	   nq2bin(iqbin)=nq2bin(iqbin)+wtx
         call hfill(221,y,0.,wtx)
         call hfill(222,q2,0.,wtx)
* weighting with photon flux
         xw = x*q2b(iqbin)*q2b(iqbin)/(1.-y+y**2/2)
         nall2=nall2+xw
         nev(1000+iqbin)=nev(1000+iqbin)+wtx
c         write(6,*) q2,q2b(iqbin),iqbin,xw,wtx
         call hfill(1000+iqbin,x,0.,xw*wtx)
	   
c	   call hfill(4000,real(log(xsim)),0.,real(wtx))
c	   call hfill(5000,real(log(ykt)),0.,real(wtx))
	   
c	   call hfill(4000+iqbin,real(log(xsim)),0.,real(wtx))
c	   call hfill(5000+iqbin,real(log(ykt)),0.,real(wtx))
         
c	   write(6,*) ' hz96039 ',log(xsim),log(ykt)
	   
c	   if(x.lt.0.01.and.q2.gt.5.) then
c            if(gen(1:3).eq.'RAP') then
c               igl1=4
c               igl2=6
c            elseif(gen(1:3).eq.'PYT') then
c               igl1= 5
c               igl2= 6
c            endif
c            xkt2 = real(sqrt(phep(1,igl2)**2+phep(2,igl2)**2))
c            x2=(phep(4,igl2)+dabs(phep(3,igl2)))/2d0/phep(4,2)
c            call hfill(31,real(log10(x2)),0.,1.)
c            call hfill(32,xkt2,0.,1.)
            		
c		write(6,*) ' hz96039 kt= ', xkt2,' xg = ',x2,' x = ',x
c	   endif
*
*
*
* determine kin bin of event
*                                             get electron variables
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* fill histos with f2 from pdf

         do i=1,14
            do j=1,nxbin

               dx = dble(xcenter(j))
               dq = dble(sqrt(q2b(i)))
               PARM(1) = 'NPTYPE'
               VAL(1) = 1.d0
               PARM(2) = 'NGROUP'
               VAL(2) = 5.d0
               PARM(3) = 'NSET'
               VAL(3) = 7.D0
               NPDF=NPDF+1
               PDFFIRST=.FALSE.
               IF(NPDF.LE.1) PDFFIRST=.TRUE.
c               CALL PDFSET(PARM,VAL)
c               CALL STRUCTM(dx,dq,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,
c     +         GLU)
               f2pdf=real(4./9.*(upv+usea) + 1./9.*(dnv+dsea) + 8./9.*
     +         (chm+top) + 2./9.*(str+bot) +
     +         4./9.*usea + 1./9.*dsea)
c                write(6,*) ' f2pdf ',xcenter(j),f2pdf
               call hfill(2000+i,xcenter(j),0.,f2pdf)
            enddo
         enddo
         if (lp) then
*
*
* Obtain total cross-section
            write(6,*) ' Total Cross section ',xsec,nall
*
            write(6,*)'      '
         endif
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif

*      normalize the histos
         if(nall2.gt.1) then
* now do the cross section normalisation
            do i1=1,14
cc		   write(6,*)' q2 bins ',i1,q2bin(i1)/nq2bin(i1),
c     &		   q2bin(i1),nq2bin(i1)
               idhisto= 1000 +i1
		   idpaw = idhisto
               call hzhinfo(idpaw,int(nev(idhisto)))
               if(nev(idhisto).gt.1) then

cc		      write(6,*) ' hz96039 norm in bin i1: ',i1,nev(idhisto)
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /q2binw(i1)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)

c                  if(i1.ge.4) then
c                     call mychisq(-idhisto-100,idhisto,chi,ndf)
c			   chit = chit + chi
c			   ndft = ndft + ndf
c			write(6,*) ' hz... ',chi,ndf,-idhisto-100,idhisto
c			endif
ccc                  call hzchisq(-idhisto-100,idhisto)
cc                  write(6,*) ' after opera, chi '
               endif 
		   
            enddo
c            call hzhinrm( 4000, 0, 1./lum, 1 )
c            call hzhinrm( 5000, 0, 1./lum, 1 )
              
c		call hzhinrm( 41, 0, 1., 1 )
c            call hopera(41,'+E',41,41,1./lum/1000.,0.)
c		call hzhinrm( 42, 0, 1., 1 )
c            call hopera(42,'+E',42,42,1./lum/1000.,0.)
         endif
*
*
*
      endif
      RETURN
      END
