      subroutine HZ96138(IFLAG)
***********************************************
* D*-data Fcc
*-- Author :  Frank Botterweck 25-05-96*
***********************************************
      IMPLICIT NONE
*
      real et,rap,rapl
      real enel,thel
      real s_inter
      Real pi,dpi,rd,ee,eb,dphi
      Real xpt1,xpt2,xxd1,xxd2
      Logical evcut,lp
      data lp/.false./
*
      Character string*20
*
      Integer nev
      Data nev/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.6)
*
      Integer ierr,ibeam,igam
      Real nnf2cc
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real parl270, parl271
      real qch(-6:6)
      integer kf,ix,nentry,iq
      real xpq(-6:6),sf2
      integer lst
      real cut,parl,x,y,w2,q2,u
      common/leptou/cut(14),lst(40),parl(30),x,y,w2,q2,u
       integer ixxl10
       real xxl10,xx,xf2,xf2cc
      real kd_delxq(10)
*
      Real nd0,ndplus
      integer ib_kd, iq_bin
      real dif1,dif2,dif3
      real kd_avx(0:10),kd_avq(0:10),tevt
      data kd_avx/11*0./,kd_avq/11*0./
      integer id0,id1,id2,id3
      integer id11,id21
      integer i_q1,i_q2,id_q1,id_q2
      real    kd_evt(10,0:10)
      data kd_evt/110*0./
      double precision p4l_q1(4),p4l_q2(4)
      double precision p4c_q1(4),p4c_q2(4)
      real shat12
     & ,pc_q1,ptc_q1,etc_q1,thc_q1,rapc_q1
     & ,pc_q2,ptc_q2,etc_q2,thc_q2,rapc_q2
     & ,pl_q1,ptl_q1,etl_q1,thl_q1,rapl_q1
     & ,pl_q2,ptl_q2,etl_q2,thl_q2,rapl_q2
     & ,xc_q1,xc_q2
      real phip1p2,p1p2

       integer my_q2,my_xb
       integer iq2bin,ixbbin
       Integer nmybins,nsq
       Parameter (nmybins=12,nsq=nmybins*nmybins)
       real xblow(nmybins)
       data xblow/0.0001,0.0004,0.0006,0.001,0.005,
     & 0.01,0.015,0.05,0.1,0.3,0.5,1./
       real q2low(nmybins)
       data q2low/10.,20.,30.,50.,100.,500.,1000.,
     & 2500.,5000.,10000.,15000.,20000./
*
       real av_xb(nmybins,nmybins),av_q2(nmybins,nmybins)
       real av_y (nmybins,nmybins),xevt(nmybins,nmybins),xntot
       real xevt_c(nmybins,nmybins)
       data av_xb/nsq*0./
       data av_q2/nsq*0./
       data av_y /nsq*0./
       data xevt/nsq*0./,xntot/0./
       data xevt_c/nsq*0./
*
       real xv
       real del_q2,del_xb
       real qqradp
       real xkinfac,qpi , xf21,xf21cc,xf22 , sigma_tot, xf23,xf23cc
       real xf24,xf25,xf26
       real avxb,avq2,avy
*
       integer max_xd,max_xd2
       parameter (max_xd=6,max_xd2=5)
       real xd_bin(max_xd+1)
       data xd_bin/0.,0.1,0.25,0.4,0.55,0.7,1./
       real xd_bin2(max_xd2+1)
       data xd_bin2/0.1,0.25,0.4,0.55,0.65,1./
       integer max_pt,max_pt2
       parameter (max_pt=6,max_pt2=5)
       real pt_bin(max_pt+1),pt_bin2(max_pt2+1)
       data pt_bin/0.,1.,2.,3.,4.,6.,10./
       data pt_bin2/1.,2.,3.,4.,6.,10./
*
* Pt spectra
*
       Real pty1d(max_pt2), ptey1d(max_pt2),ptx2d(max_pt2)
       Real pty2d(max_pt2), ptey2d(max_pt2)
       Real ptex1d(max_pt2),ptex2d(max_pt2)
       Real ptx1d(max_pt2)
*      D0
       data pty1d /0., 0.333,0.115,0.0404,0.0076/
       data ptey1d/0. ,  0.069,0.026,0.009, 0.0029/
       data ptx2d /1.5,  2.5  ,3.5  ,5.    ,8.    /
*      D*
       data pty2d /0.513,0.230,0.110,0.035 ,0.0028/
       data ptey2d/0.158,0.058,0.027,0.0093,0.0017/
       data ptex1d/max_pt2*0./
       data ptex2d/max_pt2*0./
*
* F2 data
*
       Integer nf2
       Parameter (nf2=9)
       Real xx1(nf2),yy1(nf2),xx2(nf2),yy2(nf2),xx3(nf2),yy3(nf2)
       Real eyy1(nf2),eyy2(nf2),eyy3(nf2)
*
       Data xx1/0.00032,0.0005, 0.0008, 0.0013, 0.002 , 0.0032, 0.005,
     &           0.008, 0.013/
       Data yy1/ 1.276, 1.168 , 1.067 , 0.942 , 0.866 , 0.749 , 0.685,
     &           0.618, 0.531/
       Data xx2/0.0005, 0.0008, 0.0013, 0.002 , 0.0032, 0.0050, 0.008,
     &          0.0130, 0.02/
       Data yy2/1.546 , 1.330 , 1.151 , 1.019 , 0.872 , 0.768 , 0.683,
     &          0.585 ,0.548/
       Data xx3/0.0013, 0.0020, 0.0032, 0.005 , 0.0080, 0.0130, 0.020,
     &          0.0320,0.05/
       Data yy3/1.3050, 1.2250, 1.1050, 0.912 , 0.7430, 0.6860, 0.599,
     &          0.5050,0.4110/
*
* F2cc data
*
       Integer nf2cc
       Parameter (nf2cc=2)
       Real xcc1(nf2cc), ycc1(nf2cc), eycc1(nf2cc), sycc1(nf2cc)
       Real xcc2(nf2cc), ycc2(nf2cc),  eycc2(nf2cc), sycc2(nf2cc)
       Real xcc3(nf2cc), ycc3(nf2cc) , eycc3(nf2cc), sycc3(nf2cc)
       Real excc(nf2cc),xbin1(nf2cc+1),xbin2(nf2cc+1),xbin3(nf2cc+1)
* bin 1 Q2=12 GeV2
       Data xbin1/0.000251,0.001,0.01/
       Data xcc1 /0.0008, 0.0032/
       Data ycc1/0.211  , 0.190/
       Data eycc1/0.049 , 0.054/
       Data sycc1/0.040 , 0.050/
* bin 2 Q2= 25 GeV2
       Data xbin2/0.000631,0.00158,0.01/
       Data xcc2 /0.0008, 0.0032/
       Data ycc2 /0.324 , 0.222/
       Data eycc2/0.099 , 0.066/
       Data sycc2/0.060 , 0.040/
* bin 3 Q2= 45 GeV2
       Data xbin3/0.00158,0.00398,0.0158/
       Data xcc3 /0.002 , 0.008/
       Data ycc3 /0.156 , 0.200/
       Data eycc3/0.070 , 0.064/
       Data sycc3/0.030 , 0.035/
       Data excc /nf2cc*0./
*
* Ratio F2/F2cc
*
       Real rxcc1(nf2cc), rycc1(nf2cc), reycc1(nf2cc), rsycc1(nf2cc)
       Real rxcc2(nf2cc), rycc2(nf2cc), reycc2(nf2cc), rsycc2(nf2cc)
       Real rxcc3(nf2cc), rycc3(nf2cc), reycc3(nf2cc), rsycc3(nf2cc)
       Real rexcc(nf2cc)
       Data rxcc1 /0.0008, 0.0032/
       Data rycc1 /0.198 , 0.254/
       Data reycc1/0.045 , 0.072/
       Data rsycc1/0.033 , 0.058/
       Data rxcc2 /0.0008, 0.0032/
       Data rycc2 /0.244 , 0.255/
       Data reycc2/0.075 , 0.076/
       Data rsycc2/0.038 , 0.038/
       Data rxcc3 /0.0020, 0.0080/
       Data rycc3 /0.127 , 0.269/
       Data reycc3/0.059 , 0.088/
       Data rsycc3/0.020 , 0.039/
       Data rexcc /nf2cc*0./
*
* Xd data
*
       Real x1d(max_xd2),y1d(max_xd2),ey1d(max_xd2),y2d(max_xd2)
       Real ey2d(max_xd2),ex1d(max_xd2),ex2d(max_xd2)
       Real x2d(max_xd2)
*
       data x1d / .175, .325,.475,.625,.85/
*      D0
       data y1d / 0.0, 2.4, 1.21, .68, .071/
       data ey1d/ 0.0, 0.4, 0.29,0.14,0.029/
*      D*
       data y2d / 2.4, 1.6, 1.2,  .4,  .086/
       data ey2d/ 0.6, 0.24,0.15,0.036,0.001/
       data ex1d/max_xd2*0./
       data ex2d/max_xd2*0./
*
       real efwd , th , phdum, pt , p ,x_d
       real xncc,xncc1,xncc2
       data xncc/0/,xncc1/0/,xncc2/0/
       logical lctag,lstag
       integer idhe,idda1,idda2,idmo1,idmo2
*
       real xnd0,alphem
       data xnd0/0./
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'96138'/

      save nnf2cc, nd0, ndplus, parl270, parl271, Qpi, qqradp, 
     &     xntot, nev

*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
       nnf2cc=0.
       nd0=0.
       ndplus=0.
       parl270= 99999.
       parl271=-99999.
       write(6,*) 'Hz',xxxx,' CCbar Version'
       Qpi = 4.*atan(1.)
       qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')
*
       id0 = 3000
       id1 = 3100
       id11 = 3110
       id2 = 3200
       id21 = 3210
       id3 = 3300
* shat12 distribution
C         call hbook1(id0+1,' BGF Shat 12 all ',100,0.,100.,0.)
C         call hbook1(id0+3,' BGF Shat 12 CCb ',100,0.,100.,0.)
*
* theta lab distribution of BGF quarks
C         call hbook1(id1+1,' BGF quarks theta_lab All'
C     &  , 90.,0.,180.,0.)
C         call hbook1(id1+2,' BGF quarks theta_lab shat12 gt 10'
C     &  , 90.,0.,180.,0.)
C         call hbook1(id1+3,' BGF quarks theta_lab ccB '
C     &  , 90.,0.,180.,0.)
* theta lab distribution of BGF quarks
C         call hbook1(id11+1,' BGF quarks etacms All'
C     &  , 40,-10.,10.,0.)
C         call hbook1(id11+2,' BGF quarks etacms shat12 gt 10'
C     &  , 40,-10.,10.,0.)
C         call hbook1(id11+3,' BGF quarks etacms ccB '
C     &  , 40,-10.,10.,0.)
*
* x_c = 2*E_c* / w
C         call hbook2(id21+1,'BGF 2Ecms/W vs etacms quarks all '
C     &  , 40,-10.,10.,50.,0.,1.,0.)
C         call hbook2(id21+2,'BGF 2Ecms/W vs etacms quarks shat12 gt 10'
C     &  , 40,-10.,10.,50.,0.,1.,0.)
C         call hbook2(id21+3,'BGF 2Ecms/W vs etacms quarks ccB '
C     &  , 40,-10.,10.,50.,0.,1.,0.)
* x_c = 2*E_c* / w
C         call hbook2(id2+1,'BGF 2Ecms/W vs thetaLab quarks all '
C     &  , 90,0.,180.,50.,0.,1.,0.)
C         call hbook2(id2+2,'BGF 2Ecms/W vs thetaLab quarks shat12 gt 10'
C     &  , 90,0.,180.,50.,0.,1.,0.)
C         call hbook2(id2+3,'BGF 2Ecms/W vs thetaLab quarks ccB '
C     &  , 90,0.,180.,50.,0.,1.,0.)
* opening angle of quarks in Lab vs W
C         call hbook2(id3+1,' BGF Lab open ang qqB vs W All '
C     &    ,100,0.,200.,90.,0.,180.,0.)
C         call hbook2(id3+2,' BGF Lab open ang qqB vs W shat12 gt 10'
C     &    ,100,0.,200.,90.,0.,180.,0.)
C         call hbook2(id3+3,' BGF Lab open ang qqB vs W ccBar '
C     &    ,100,0.,200.,90.,0.,180.,0.)
C
C      call hbook1(1000,'d0 multi ',11,-0.5,10.5,0.)
C      call hbook1(2000,'cctag ',1,0.,1.,0.)
*
       call hbookb(1001,'pt d0 direct ',max_pt,pt_bin,0.)
       call hbookb(1002,'pt d0 from d*+',max_pt,pt_bin,0.)
       call hbookb(2001,'xd d0 direct ',max_xd,xd_bin,0.)
       call hbookb(2002,'xd d0 from d*+',max_xd,xd_bin,0.)
*
       call hbookb(1,'pt d0 direct   ',max_pt2,pt_bin2,0.)
       call hbookb(2,'pt d0 from d*+ ',max_pt2,pt_bin2,0.)
       call hbookb(-1,'pt d0 direct  ',max_pt2,pt_bin2,0.)
       call hbookb(-2,'pt d0 from d*+',max_pt2,pt_bin2,0.)
       call hbookb(101,'pt d0 direct   ',max_pt2,pt_bin2,0.)
       call hbookb(102,'pt d0 from d*+ ',max_pt2,pt_bin2,0.)
*
       call hpak(-1, pty1d)
       call hpake(-1,ptey1d)
       call hpak(-2, pty2d)
       call hpake(-2,ptey2d)
*
       call hbookb(11 ,'xd d0 direct  ',max_xd2,xd_bin2,0.)
       call hbookb(12 ,'xd d0 from d*+',max_xd2,xd_bin2,0.)
       call hbookb(-11,'xd d0 direct  ',max_xd2,xd_bin2,0.)
       call hbookb(-12,'xd d0 from d*+',max_xd2,xd_bin2,0.)
       call hbookb(111 ,'xd d0 direct  ',max_xd2,xd_bin2,0.)
       call hbookb(112 ,'xd d0 from d*+',max_xd2,xd_bin2,0.)
       call hpak(-11,y1d )
       call hpake(-11,ey1d)
       call hpak(-12,y2d )
       call hpake(-12,ey2d)
*
*****************************
*  Make histograms of F2 , F2CC and F2CC/F2 for pure PDF function
*****************************
*

       call hbook1( 4011,'f2CC Q2=12 ',100,-5.,0.,0.)
       call hbook1( 4012,'f2CC Q2=25 ',100,-5.,0.,0.)
       call hbook1( 4013,'f2CC Q2=45 ',100,-5.,0.,0.)
       call hbook1( 4021,'f2CC/F2 Q2=12 ',100,-5.,0.,0.)
       call hbook1( 4022,'f2CC/F2 Q2=25 ',100,-5.,0.,0.)
       call hbook1( 4023,'f2CC/F2 Q2=45 ',100,-5.,0.,0.)
*
       call hbook1( 141,'f2 Q2=12 ',100,-5.,0.,0.)
       call hbook1( 142,'f2 Q2=25 ',100,-5.,0.,0.)
       call hbook1( 143,'f2 Q2=45 ',100,-5.,0.,0.)
       call hbook1(-141,'f2 Q2=12 ',100,-5.,0.,0.)
       call hbook1(-142,'f2 Q2=25 ',100,-5.,0.,0.)
       call hbook1(-143,'f2 Q2=45 ',100,-5.,0.,0.)
       Do i=1,nf2
         eyy1(i)=0.
         eyy2(i)=0.
         eyy3(i)=0.
       enddo
       call hpak(-141,yy1)
       call hpake(-141,eyy1)
       call hpak(-142,yy2)
       call hpake(-142,eyy2)
       call hpak(-143,yy3)
       call hpake(-143,eyy3)
*
       call hbookb( 241,'f2CC Q2=12 ',nf2cc,xbin1,0.)
       call hbookb( 242,'f2CC Q2=25 ',nf2cc,xbin2,0.)
       call hbookb( 243,'f2CC Q2=45 ',nf2cc,xbin3,0.)
       call hbookb(-241,'f2CC Q2=12 ',nf2cc,xbin1,0.)
       call hbookb(-242,'f2CC Q2=25 ',nf2cc,xbin2,0.)
       call hbookb(-243,'f2CC Q2=45 ',nf2cc,xbin3,0.)
       Do i=1,nf2cc
         eycc1(i)= sqrt(eycc1(i)**2+sycc1(i)**2)
         eycc2(i)= sqrt(eycc2(i)**2+sycc2(i)**2)
         eycc3(i)= sqrt(eycc3(i)**2+sycc3(i)**2)
       enddo
       call hpak(-241,ycc1)
       call hpake(-241,eycc1)
       call hpak(-242,ycc2)
       call hpake(-242,eycc2)
       call hpak(-243,ycc3)
       call hpake(-243,eycc3)
*
       call hbookb( 341,'f2CC/F2 Q2=12 ',nf2cc,xbin1,0.)
       call hbookb( 342,'f2CC/F2 Q2=25 ',nf2cc,xbin2,0.)
       call hbookb( 343,'f2CC/F2 Q2=45 ',nf2cc,xbin3,0.)
       call hbookb( -341,'f2CC/F2 Q2=12 ',nf2cc,xbin1,0.)
       call hbookb( -342,'f2CC/F2 Q2=25 ',nf2cc,xbin2,0.)
       call hbookb( -343,'f2CC/F2 Q2=45 ',nf2cc,xbin3,0.)
*
       Do i=1,nf2cc
         reycc1(i)= sqrt(reycc1(i)**2+rsycc1(i)**2)
         reycc2(i)= sqrt(reycc2(i)**2+rsycc2(i)**2)
         reycc3(i)= sqrt(reycc3(i)**2+rsycc3(i)**2)
       enddo
*
       call hpak(-341,rycc1)
       call hpake(-341,reycc1)
       call hpak(-342,rycc2)
       call hpake(-342,reycc2)
       call hpak(-343,rycc3)
       call hpake(-343,reycc3)
*
C       call hbook1( 4031,'f2 BGF Q2=12 ',100,-5.,0.,0.)
C       call hbook1( 4032,'f2 BGF Q2=25 ',100,-5.,0.,0.)
C       call hbook1( 4033,'f2 BGF Q2=45 ',100,-5.,0.,0.)
C       call hbook1( 4041,'f2 BGF CC Q2=12 ',100,-5.,0.,0.)
C       call hbook1( 4042,'f2 BGF CC Q2=25 ',100,-5.,0.,0.)
C       call hbook1( 4043,'f2 BGF CC Q2=45 ',100,-5.,0.,0.)
C       call hbook1( 4051,'f2 BGF shat gt 10 Q2=12 ',100,-5.,0.,0.)
C       call hbook1( 4052,'f2 BGF shat gt 10 Q2=25 ',100,-5.,0.,0.)
C       call hbook1( 4053,'f2 BGF shat gt 10 Q2=45 ',100,-5.,0.,0.)
C       call hbook1( 4061,'f2 BGF CC shat gt 10 Q2=12 ',100,-5.,0.,0.)
C      call hbook1( 4062,'f2 BGF CC shat gt 10 Q2=25 ',100,-5.,0.,0.)
C      call hbook1( 4063,'f2 BGF CC shat gt 10 Q2=45 ',100,-5.,0.,0.)
C       call hbook1(-4001,'PDF f2 Q2=12 ',100,-5.,0.,0.)
C       call hbook1(-4002,'PDF f2 Q2=25 ',100,-5.,0.,0.)
C       call hbook1(-4003,'PDF f2 Q2=45 ',100,-5.,0.,0.)
C       call hbook1(-4011,'PDF f2CC Q2=12 ',100,-5.,0.,0.)
C       call hbook1(-4012,'PDF f2CC Q2=25 ',100,-5.,0.,0.)
C       call hbook1(-4013,'PDF f2CC Q2=45 ',100,-5.,0.,0.)
C       call hbook1(-4021,'PDF f2CC/F2 Q2=12 ',100,-5.,0.,0.)
C       call hbook1(-4022,'PDF f2CC/F2 Q2=25 ',100,-5.,0.,0.)
C       call hbook1(-4023,'PDF f2CC/F2 Q2=45 ',100,-5.,0.,0.)
C       do ixxl10=1,100
C        xxl10 = -4.975+ (5.*ixxl10-5.)/100
C        xx=10.**xxl10
C        write(6,*)' HZ96F2 calling PDFGET2 ',xx,12.
C            call pdfget2(xx,12.,xf2,xf2cc)
C        write(6,*)' HZ96F2 after PDFGET2 ',xf2,xf2cc
C        call hfilL(-4001,xxl10,1.,xf2)
C        call hfill(-4011,xxl10,1.,xf2cc)
C        call hfill(-4021,xxl10,1.,xf2cc/xf2)
C        write(6,*)' HZ96F2 calling PDFGET2 ',xx,12.
C            call pdfget2(xx,25.,xf2,xf2cc)
C        write(6,*)' HZ96F2 after PDFGET2 ',xf2,xf2cc
C        call hfill(-4002,xxl10,1.,xf2)
C        call hfill(-4012,xxl10,1.,xf2cc)
C        call hfill(-4022,xxl10,1.,xf2cc/xf2)
C        write(6,*)' HZ96F2 calling PDFGET2 ',xx,12.
C            call pdfget2(xx,45.,xf2,xf2cc)
C        write(6,*)' HZ96F2 after PDFGET2 ',xf2,xf2cc
C        call hfill(-4003,xxl10,1.,xf2)
C        call hfill(-4013,xxl10,1.,xf2cc)
C        call hfill(-4023,xxl10,1.,xf2cc/xf2)
C       enddo
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
       call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
       xntot=xntot+1
*
       q2=real(hzdiskin(1))
       x=real(hzdiskin(2))
       y=real(hzdiskin(3))
       w2=real(hzdiskin(4))
*
       if (parl(27).gt.parl271 ) parl271=parl(27)
       if (parl(27).lt.parl270 ) parl270=parl(27)
       if (lp) write(6,*)'parl27 ' ,parl(27),parl271,parl271
*
*
* determine kin bin of event
*
       my_q2 = 0
       my_xb = 0
       do iq2bin = 1,nmybins
       if ( q2.gt. q2low(iq2bin) ) my_q2=iq2bin
       enddo
       do ixbbin = 1,nmybins
       if ( x .gt. xblow(ixbbin) ) my_xb=ixbbin
       enddo
*
       if (lp) write(6,*)' q2,x,my_q2,my_x= ',q2,x,my_q2,my_xb
*
* If event in bin, update event number, and averages x, Q2 and y
*
       if ( my_q2.gt.0 .and. my_q2.le.nmybins .AND.
     &      my_xb.gt.0 .and. my_xb.le.nmybins ) then
*
         xevt(my_q2,my_xb) = xevt(my_q2,my_xb)  +1
*
         if (lp) then
          write(6,*) ' my_q2,my_xb= ',my_q2,my_xb
          write(6,*) ' xevt(my_q2,my_xb) = ',xevt(my_q2,my_xb)
         endif
*
         xv = xevt(my_q2,my_xb)
         av_xb(my_q2,my_xb) = (xv-1.)/xv* av_xb(my_q2,my_xb)
     &  + 1./xv * x
         av_q2(my_q2,my_xb) = (xv-1.)/xv* av_q2 (my_q2,my_xb)
     &  + 1./xv * q2
         av_y (my_q2,my_xb) = (xv-1.)/xv* av_y (my_q2,my_xb)
     &  + 1./xv * y
*
        if (lp) then
*
         write(6,*) ' xv= ',xv,'  av_xb= ',av_xb(my_q2,my_xb)
         write(6,*) ' xv= ',xv,'  av_q2= ',av_q2(my_q2,my_xb)
         write(6,*) ' xv= ',xv,'  av_y = ',av_y (my_q2,my_xb)
*
        endif
*
       endif
*
* boost crap!
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
        write(6,*) 'Hz'//xxxx,' electron not found '
        goto 9990
       endif
       enel=real(PHEP(4,iel))
       thel=real(HZPHMANG(PHEP(3,iel),
     &               sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2)))*rd
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' enel= ',enel,' thel= ',thel
*
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
        write(6,*) 'HZ'//xxxx,' beams not found ! '
        goto 9990
       else
        Do i=1,4
         pbeam(i)=PHEP(i,IBEAM)
        enddo
       endif
*
       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).gt.0.2) then
        if (nentry.lt.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
        elseif (nentry.eq.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &   ' ...last message ! '
        endif
C        goto 9990
       endif
*
       ierr=HZIPGAM(ph)
       if (ierr.eq.-1) then
        write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C        call VZERO(ph,5)
        Do i=1,5
         ph(i)=0.
        enddo
       else
        Do i=1,4
         pgam(i)=ph(i)
        enddo
       endif
*
       call HZHCMINI(pbeam,pgam,ierr)
       if (ierr.eq.1) then
        write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
        goto 9990
       endif

*       write(6,*)'BGF event LST24/25/26 ',lst(24),lst(25),lst(26)
*       write(6,*)'BGF event PAR27/28/29/30 '
*     &  ,parl(27),parl(28),parl(29),parl(30)
*       if ( lst(24).eq.3) call lulist(2)
*
* Study QQbar event in BGF
*
        call get_kd_bin(x,q2,ib_kd)
        
        if(ib_kd.le.0) return
*
        if (lp) then
         write(6,*) ' x q2= ',x,q2,' ib_kd= ',ib_kd
        endif
*
C       if (     10. .gt. q2 .and. q2 .lt. 100.
C     &   .and. 0.01 .lt.  y .and.  y .lt. .7  ) then
*
*  (1)  all events
*
         tevt =  kd_evt(1,0) + 1
         kd_evt(1,0) = tevt
         if (lp) then
          write(6,*) ' kd_evt(1,0)= ',kd_evt(1,0)
         endif

         kd_avq(0) =
     &    (tevt-1.)/tevt* kd_avq(ib_kd)+1./tevt*q2
         kd_avx(0) =
     &    (tevt-1.)/tevt* kd_avx(ib_kd)+1./tevt*x
        if (ib_kd .ge. 1. .and. ib_kd.le.6)then
         tevt =  kd_evt(1,ib_kd) + 1.
         kd_evt(1,ib_kd) = tevt
*
         if (lp) then
          write(6,*) ' kd_evt(1,ib_kd)= ',kd_evt(1,ib_kd)
         endif
*
         kd_avq(ib_kd) =
     &    (tevt-1.)/tevt* kd_avq(ib_kd)+1./tevt*q2
         kd_avx(ib_kd) =
     &    (tevt-1.)/tevt* kd_avx(ib_kd)+1./tevt*x
*
         if (lp) then
          write(6,*) ib_kd,' kd_avx(ib_kd)= ', kd_avx(ib_kd)
         endif
*
C        endif
*
C       if ( lst(24).eq.3) then
*  (2)  all BGF  events
C        kd_evt(2,0) = kd_evt(2,0) + 1.
C        if (ib_kd .ge. 1. .and. ib_kd.le.6)then
C        kd_evt(2,ib_kd) = kd_evt(2,ib_kd) + 1.
C        endif
C         i_q1 = lst(26)
C         i_q2 = lst(26)+1
C         id_q1 = idhep(i_q1)
C         id_q2 = idhep(i_q2)
C         if ( id_q1 + id_q2 .ne. 0) then
C           write(6,*)' Impossible BGF event '
C         endif
*
*  (3)  all BGF  events with ccbar
C        if ( abs(id_q1).eq.4) then
C         kd_evt(3,0) = kd_evt(3,0) + 1.
C         if (ib_kd .ge. 1. .and. ib_kd.le.6)then
C          kd_evt(3,ib_kd) = kd_evt(3,ib_kd) + 1.
C         endif
C        endif
*
C         do i=1,4
C         p4l_q1(i) = phep(i,i_q1)
C         p4l_q2(i) = phep(i,i_q2)
C         enddo
C           call HZHCM(p4l_q1,p4c_q1,ierr)
C           call HZHCM(p4l_q2,p4c_q2,ierr)
C         shat12 = (p4l_q1(4) + p4l_q2(4) ) **2
C     &          - (p4l_q1(1) + p4l_q2(1) ) **2
C     &          - (p4l_q1(2) + p4l_q2(2) ) **2
C     &          - (p4l_q1(3) + p4l_q2(3) ) **2
*
C         call hzgetvar(p4l_q1
C     & ,pl_q1,ptl_q1,etl_q1,thl_q1,rapl_q1,err_flag)
C         if ( err_flag.ne.0) write(6,*)' qqbar error 1 '
C         call hzgetvar(p4l_q2
C     & ,pl_q2,ptl_q2,etl_q2,thl_q2,rapl_q2,err_flag)
C         if ( err_flag.ne.0) write(6,*)' qqbar error 2 '
*
C         call hzgetvar(p4c_q1
C     & ,pc_q1,ptc_q1,etc_q1,thc_q1,rapc_q1,err_flag)
C         if ( err_flag.ne.0) write(6,*)' qqbar error 1 '
C         call hzgetvar(p4c_q2
C     & ,pc_q2,ptc_q2,etc_q2,thc_q2,rapc_q2,err_flag)
C         if ( err_flag.ne.0) write(6,*)' qqbar error 2 '
*
*   (4) all BGF  events with shat > 10
C         if (shat12.gt.10. )then
C          kd_evt(4,0) = kd_evt(4,0) + 1.
C          if (ib_kd .ge. 1. .and. ib_kd.le.6)then
C           kd_evt(4,ib_kd) = kd_evt(4,ib_kd) + 1.
C          endif
C         endif
*   (5) all BGF ccbar  events with shat > 10
C         if (shat12.gt.10. .and. abs(id_q1).eq.4 )then
C             kd_evt(5,0) = kd_evt(5,0) + 1.
C          if (ib_kd .ge. 1. .and. ib_kd.le.6)then
C           kd_evt(5,ib_kd) = kd_evt(5,ib_kd) + 1.
C          endif
C         endif
*
* shat12 distribution
C         call hfill(id0+1,shat12,1.,1.)
C         if ( abs(id_q1) .eq. 4 ) then
C         call hfill(id0+3,shat12,1.,1.)
C         endif
*
* eta cms  distribution of BGF quarks
C         call hfill(id11+1,rapc_q1,1.,1.)
C         call hfill(id11+1,rapc_q2,1.,1.)
C         if ( shat12.gt.10. ) then
C         call hfill(id11+2,rapc_q1,1.,1.)
C         call hfill(id11+2,rapc_q2,1.,1.)
C         endif
C         if ( abs(id_q1) .eq. 4 ) then
C         call hfill(id11+3,rapc_q1,1.,1.)
C         call hfill(id11+3,rapc_q2,1.,1.)
C         endif
*
* theta lab distribution of BGF quarks
C         call hfill(id1+1,thl_q1*qqradp,1.,1.)
C         call hfill(id1+1,thl_q2*qqradp,1.,1.)
C         if ( shat12.gt.10. ) then
C          call hfill(id1+2,thl_q1*qqradp,1.,1.)
C          call hfill(id1+2,thl_q2*qqradp,1.,1.)
C         endif
C         if ( abs(id_q1) .eq. 4 ) then
C          call hfill(id1+3,thl_q1*qqradp,1.,1.)
C          call hfill(id1+3,thl_q2*qqradp,1.,1.)
C         endif
*
* x_c = 2*E_c* / w
*
C         xc_q1 = 2.*p4c_q1(4)/sqrt(w2)
C         xc_q2 = 2.*p4c_q2(4)/sqrt(w2)
C         call hfill(id2+1,thl_q1*qqradp,xc_q1,1.)
C         call hfill(id2+1,thl_q2*qqradp,xc_q2,1.)
C         call hfill(id21+1,rapc_q1,xc_q1,1.)
C         call hfill(id21+1,rapc_q2,xc_q2,1.)
C         if ( shat12.gt.10. ) then
C          call hfill(id2+2,thl_q1*qqradp,xc_q1,1.)
C          call hfill(id2+2,thl_q2*qqradp,xc_q2,1.)
C          call hfill(id21+2,rapc_q1,xc_q1,1.)
C          call hfill(id21+2,rapc_q2,xc_q2,1.)
C         endif
C         if ( abs(id_q1) .eq. 4 ) then
C          call hfill(id2+3,thl_q1*qqradp,xc_q1,1.)
C          call hfill(id2+3,thl_q2*qqradp,xc_q2,1.)
C          call hfill(id21+3,rapc_q1,xc_q1,1.)
C          call hfill(id21+3,rapc_q2,xc_q2,1.)
C         endif
*
* opening angle of quarks in Lab vs W
*
C         p1p2 = ( p4l_q1(1)* p4l_q2(1)
C     &          + p4l_q1(2)* p4l_q2(2)
C     &          + p4l_q1(3)* p4l_q2(3) )/pl_q1/pl_q2
C         phip1p2 = acos(p1p2)*qqradp
C         call hfill(id3+1,sqrt(w2),phip1p2,1.)
C         if ( shat12.gt.10. ) then
C          call hfill(id3+2,sqrt(w2),phip1p2,1.)
C         endif
C         if ( abs(id_q1) .eq. 4 ) then
C          call hfill(id3+3,sqrt(w2),phip1p2,1.)
C         endif
*
* ENDIF BGF
C        endif
*
* ENDIF kin range
       endif
*
       efwd=0.
       lctag=.false.
       xnd0=0
       nev=nev+1
       Do 2000 ihep=1,nhep
        idhe=idhep(ihep)
*
        if ( abs(idhe).eq.4 ) lctag=.true.
        if ( abs(idhe).eq.311 ) lstag=.true.
*
        if ( abs(idhe) .eq. 421 ) then
           Do i=1,4
            Phc(i)=PHEP(i,ihep)
           enddo
* pcm in had cms
           call HZHCM(phc,pcm,ierr)
           if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            goto 9990
           endif
*
*                                             get particle momenta
*
* Lab variables
*
           call hzgetvar(phc,p,pt,et,th,phdum,rapl,err_flag)
           if ( err_flag.ne.0 ) goto 2000
*
* CMS variables
           call hzgetvar(pcm,p,pt,et,th,phdum,rap,err_flag)
           if ( err_flag.ne.0 ) goto 2000
*
          idmo1=jmohep(1,ihep)
          idmo2=idhep(idmo1)
*          write(6,*)' D0 found ',xntot,lctag,idmo1,idmo2
          xnd0=xnd0+1
          x_d = 2*abs(p)/sqrt(w2)
*
          if (lp) write(6,*) ' x_d= ',x_d,' p= ',p,' w2= ',w2
*
          if ( idmo2 .eq. 413 ) then
*           write(6,*)' d0 from d*+ '
           call hfill(1002,pt,1.,wtx)
           call hfill(2002,x_d,1.,wtx)
           call hfill(2,pt,1.,wtx)
           call hfill(12,x_d,1.,wtx)
           ndplus=ndplus+wtx
           call hfill(102,pt,1.,wtx)
           call hfill(112,x_d,1.,wtx)
          else
           call hfill(1001,pt,1.,wtx)
           call hfill(2001,x_d,1.,wtx)
           call hfill(1,pt,1.,wtx)
           call hfill(11,x_d,1.,wtx)
           nd0=nd0+wtx
           call hfill(101,pt,1.,wtx)
           call hfill(111,x_d,1.,wtx)

*           if (abs(rapl).lt.1.5)call hfill(2001,x_d,1.,wtx)
          endif
*
          if (lp) write(6,*) ' pt x_d= ',pt,x_d,' ndplus= ',ndplus,nd0
*
        endif
*
*        if (isthep(ihep).eq.1.and.ihep.ne.iel) then
*         if(th.gt.4.4.and.th.lt.15.) then
*          efwd=real(PHEP(4,ihep))+efwd
*         endif
*        endif
*
 2000  continue
*
*       if ( lstag) call lulist(2)
C       if ( abs(lst(25)) .ne. 4. .and. lctag) then
C         write(6,*)' ccbar from? ',lst(25),lctag
C         xncc1=xncc1+1
*         call lulist(2)
C       endif
C       if ( abs(lst(25)) .eq. 4. .and. .NOT. lctag) then
C         write(6,*)' Impossible ',lst(25),lctag
C         xncc2=xncc2+1
C       endif
       if ( lctag ) then
C        if ( lst(24).eq.3)
C     &  write(6,*)' Ctagged BGF lst25/26 ',lst(25),lst(26)
C        xncc=xncc+1.
C        call hfill(2000,0.5,1.,1.)
C         if ( my_q2.gt.0 .and. my_q2.le.5 .AND.
C     &      my_xb.gt.0 .and. my_xb.le.5  ) then
C         xevt_c(my_q2,my_xb) = xevt_c(my_q2,my_xb)  +1
C         endif
C       if (     10. .lt. q2 .and. q2 .lt. 100.
C     &   .and. 0.01 .lt.  y .and.  y .lt. .7  ) then
         kd_evt(6,0) = kd_evt(6,0) + 1.
         if (ib_kd .ge. 1. .and. ib_kd.le.6)then
          kd_evt(6,ib_kd) = kd_evt(6,ib_kd) + 1.
         endif
C       endif
       endif
*
       call hfill(1000,xnd0,1.,wtx)
*
*
*
*                                             get electron variables
 9990  continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
*
       if (lp) then
*
C        write(6,*)' parl27 0 1 ' ,parl270,parl271
C        write(6,*)' xncc ',xncc,' of ',xntot
C        write(6,*)' strnge ',xncc1,' of ',xntot
C        write(6,*)' wrong ',xncc2,' of ',xntot
*
* Obtain total cross-section
        write(6,*)
     &  ' Total Cross section ',xsec,ntot
*
        write(6,*)'      '
        write(6,*)' KD evt counter ALL                  ',kd_evt(1,0)
C        write(6,*)' KD evt counter BGF                  ',kd_evt(2,0)
C     &     ,kd_evt(2,0)/kd_evt(1,0)
C        write(6,*)' KD evt counter BGF ccB              ',kd_evt(3,0)
C     &     ,kd_evt(3,0)/kd_evt(1,0)
C        write(6,*)' KD evt counter BGF     shat12 GT 10 ',kd_evt(4,0)
C     &     ,kd_evt(4,0)/kd_evt(1,0)
C        write(6,*)' KD evt counter BGF ccB shat12 GT 10 ',kd_evt(5,0)
C     &     ,kd_evt(5,0)/kd_evt(1,0)
C        write(6,*)'      '
       endif
*
* Normalize total cross-section to mbarns
      if (gen.eq.'INS') then
       sigma_tot = xsec/1000./1000.
      else
       sigma_tot = xsec/1000./1000./1000.
      endif
* Now express in Gev23
      sigma_tot = sigma_tot/0.38937966
*
      if (lp) write(6,*)' Lumi ',xntot/sigma_tot,' in nb -1 '
*
      kd_delxq(1)=abs((10.00-13.34)*(   0.000251-0.001   )) +
     &            abs((13.34-17.78)*(    0.000398-0.00158))
      kd_delxq(2)=abs((10.00-13.34)*(    0.001   -0.01   )) +
     &            abs((13.34-17.78)*(    0.00158 -0.01   ))
      kd_delxq(3)=abs((17.78-23.71)*(    0.000631-0.00158)) +
     &            abs((23.71-31.62)*(   0.000631-0.00158 ))
      kd_delxq(4)=abs((17.78-31.62)*(    0.00158 -0.01   ))
      kd_delxq(5)=abs((31.62-56.23)*(    0.001   -0.0039 )) +
     &            abs((56.23-100  )*(    0.00158 -0.00398))
      kd_delxq(6)=abs((31.62-100  )*(    0.0039  -0.0158 ))
*
* Fill Karin Daum's F2, F2cc and Ratio histogram
      do ib_kd = 1,6
        avxb = kd_avx(ib_kd)
        avq2 = kd_avq(ib_kd)
        s_inter = 4*820.*ee
        avy = avq2/avxb/s_inter
        if ( avy.lt.0. or. avy.gt.1.)then
         write(6,*)'wrong KD bins ',ib_kd,avq2,avxb,avy
        endif
*
* Kin factor  (parl(16)= alpha_em)
        alphem=1./137.
        xkinfac= 2.*qpi*alphem**2/avxb/avq2**2 *(2.-2.*avy+avy**2)
*
        if (lp) then
         write(6,*) ' xkinfac= ',xkinfac,' xntot= ',xntot,' ib= ',ib_kd
         write(6,*) ' avxb= ',avxb,' avq2= ',avq2
        endif
*
*  F2 1:from Number of events, not correcting for Delx and DelQ2
            xf21 = kd_evt(1,ib_kd)/xntot*sigma_tot
     &      /xkinfac/kd_delxq(ib_kd)
C            xf22 = kd_evt(2,ib_kd)/xntot*sigma_tot
C     &      /xkinfac/kd_delxq(ib_kd)
C            xf23 = kd_evt(3,ib_kd)/xntot*sigma_tot
C     &      /xkinfac/kd_delxq(ib_kd)
C            xf24 = kd_evt(4,ib_kd)/xntot*sigma_tot
C     &      /xkinfac/kd_delxq(ib_kd)
C            xf25 = kd_evt(5,ib_kd)/xntot*sigma_tot
C     &      /xkinfac/kd_delxq(ib_kd)
C            xf21cc = kd_evt(6,ib_kd)/xntot*sigma_tot
C     &      /xkinfac/kd_delxq(ib_kd)
*
        dif1 = abs(avq2-12.)
        dif2 = abs(avq2-25.)
        dif3 = abs(avq2-45.)
        if    (avq2.gt.5..and.avq2.le.20.) then
          iq_bin=1
        elseif(avq2.gt.20.  .and. avq2.le.40. ) then
          iq_bin=2
        elseif(avq2.gt.40.  .and. avq2.lt.100 ) then
          iq_bin=3
        endif
*
        if (lp) then
        write(6,*) ' iq= ',iq_bin,' avxb= ',avxb,' xf21= ', xf21
        endif
*
        if (ib_kd.eq.1) then
         write(string,'(a,f9.3)') ' F2 Q2= ',avq2
         call hbook1(4001,string,100,-5.,0.,0.)
        else if (ib_kd.eq.3) then
         write(string,'(a,f9.3)') ' F2 Q2= ',avq2
         call hbook1(4003,string,100,-5.,0.,0.)
        else if (ib_kd.eq.5) then
         write(string,'(a,f9.3)') ' F2 Q2= ',avq2
         call hbook1(4005,string,100,-5.,0.,0.)
        endif
*
        if (ib_kd.eq.1 .or. ib_kd.eq.2) then
         call hfill(4001,log10(avxb),1.,xf21*wtx)
        else if (ib_kd.eq.3 .or. ib_kd.eq.4) then
         call hfill(4003,log10(avxb),1.,xf21*wtx)
        else if (ib_kd.eq.5 .or. ib_kd.eq.6) then
         call hfill(4005,log10(avxb),1.,xf21*wtx)

        endif
*
C       call hfill(4010+iq_bin,log10(avxb),1.,xf21cc)
C       call hfill(4020+iq_bin,log10(avxb),1.,xf21cc/xf21)
C       call hfill(4030+iq_bin,log10(avxb),1.,xf22)
C       call hfill(4040+iq_bin,log10(avxb),1.,xf23)
C       call hfill(4050+iq_bin,log10(avxb),1.,xf24)
C       call hfill(4060+iq_bin,log10(avxb),1.,xf25)
*
        nnf2cc= nnf2cc+wtx
        call hfill(140+iq_bin,log10(avxb),1.,xf21*wtx)
        call hfill(240+iq_bin,avxb,1.,xf21cc*wtx)
        call hfill(340+iq_bin,avxb,1.,wtx*xf21cc/xf21)
*
        if (lp) then
*
         write(6,*) ' FILL xf21cc= ',xf21cc,' avxb= ',avxb
*
         write(6,*)' Bin KD ',ib_kd,avxb,avq2,avy
         write(6,*)' KD_evt 1 ',kd_evt(1,ib_kd)
     &                        ,kd_evt(1,ib_kd)/kd_evt(1,ib_kd)
C         write(6,*)' KD_evt 2 ',kd_evt(2,ib_kd)
C     &                        ,kd_evt(2,ib_kd)/kd_evt(1,ib_kd)
C         write(6,*)' KD_evt 3 ',kd_evt(3,ib_kd)
C     &                        ,kd_evt(3,ib_kd)/kd_evt(1,ib_kd)
C         write(6,*)' KD_evt 4 ',kd_evt(4,ib_kd)
C     &                        ,kd_evt(4,ib_kd)/kd_evt(1,ib_kd)
C         write(6,*)' KD_evt 5 ',kd_evt(5,ib_kd)
C     &                        ,kd_evt(5,ib_kd)/kd_evt(1,ib_kd)
C         write(6,*)' KD_evt 6 ',kd_evt(6,ib_kd)
C     &                        ,kd_evt(6,ib_kd)/kd_evt(1,ib_kd)
       endif
*
      enddo
*
* Loop over q2 and x bins
      do my_q2=1,nmybins-1
       idq2=10000+1000*my_q2
       call hbook1(idq2  ,' avQ2 ',nmybins,0.5,nmybins+0.5,0.)
       call hbook1(idq2+1,' avx  ',nmybins,0.5,nmybins+0.5,0.)
       call hbook1(idq2+2,' F2   ',nmybins,0.5,nmybins+0.5,0.)
       call hbook1(idq2+3,' F2/dx/dq2  ',nmybins,0.5,nmybins+0.5,0.)
*
       do my_xb = 1,nmybins-1
*
          avq2=av_q2(my_q2,my_xb)
          avxb=av_xb(my_q2,my_xb)
          avy =av_y (my_q2,my_xb)
*
* calculate bin width!
          del_q2 = q2low(my_q2+1) - q2low(my_q2)
          del_xb = xblow(my_xb+1) - xblow(my_xb)
*
          if (lp) then
           write(6,*) ' q2 interval '
     &      ,my_q2,' low= ',q2low(my_q2),' avq2= ',avq2,
     &      ' high= ',q2low(my_q2+1)
           write(6,*)
     &      ' xb interval ', my_xb,' low= ',xblow(my_xb),' avx= ',avxb,
     &      ' high= ',xblow(my_xb+1)
           write(6,*)' events ',xevt(my_q2,my_xb),' of ',xntot
           write(6,*)'cevents ',xevt_c(my_q2,my_xb),' of ',xntot
*
          endif
*
* If there are events in a bin, calculate F2
          if (avq2.gt.0.and.avxb.gt.0.) then
*
* Kin factor  (parl(16)= alpha_em)
            xkinfac= 2.*qpi*alphem**2/avxb/avq2**2 *(2.-2.*avy+avy**2)
*
*  F2 1:from Number of events, not correcting for Delx and DelQ2
            xf21 = xevt(my_q2,my_xb)/xntot*sigma_tot
     &      /xkinfac
*
*
*  F2 2: from density distribution (using Lepto routine)
C            call get_my_f2(avxb,avq2,xf22)
*
*  F2 3:from PDF lib (using Arkadi's routine)
C            call pdfget2(avxb,avq2,xf23,xf23cc)
*
*  write F21, F21/Delx/DelQ2   F22 and F23
C            if (lp) then
             write(6,'(A,F9.6,a,f9.1,a,f9.6,a,f9.6)')
     &       ' <xb>= ',avxb,' <Q2>= ',avq2,
     &       ' F2= ',xf21,' F2/dxdq2= ',xf21/del_xb/del_q2
C            endif
*
            call hfill(idq2  ,real(my_xb),1.,avq2*wtx)
            call hfill(idq2+1,real(my_xb),1.,avxb*wtx)
            call hfill(idq2+2,real(my_xb),1.,xf21*wtx)
            call hfill(idq2+3,real(my_xb),1.,wtx*xf21/del_xb/del_q2)
*
          else
C            write(6,*)' No F2 available '
          endif
        enddo
      enddo
*
*     normalise Pt and Xd to total integral
*
       call hrebin(1 ,ptx1d,pty1d,ptex1d,ptey1d,max_pt2,1,max_pt2)
       call hrebin(2 ,ptx2d,pty2d,ptex2d,ptey2d,max_pt2,1,max_pt2)
       call hrebin(11,  x1d,  y1d,  ex1d,  ey1d,max_xd2,1,max_xd2)
       call hrebin(12,  x2d,  y2d,  ex2d,  ey2d,max_xd2,1,max_xd2)
*
       if (lp) write(6,*) ' y1d= ',y1d,' y2d= ',y2d
*
       xpt1=0.
       xpt2=0.
       xxd1=0.
       xxd2=0.
       do i=1,max_pt2
        xpt1=xpt1+pty1d(i)
        xpt2=xpt2+pty2d(i)
       enddo
       Do i=1,max_xd2
        xxd1=xxd1+y1d(i)
        xxd2=xxd2+y2d(i)
       enddo
*
       Do i=1,max_pt2
        if (xpt1.ne.0.) then
         pty1d(i)=pty1d(i)/xpt1/ptex1d(i)/2.
         ptey1d(i)=ptey1d(i)/xpt1/ptex1d(i)/2.
        else
         pty1d(i)=-999.
         ptey1d(i)=0.
        endif
        if (xpt2.ne.0.) then
         pty2d(i)=pty2d(i)/xpt2/ptex2d(i)/2.
         ptey2d(i)=ptey2d(i)/xpt2/ptex2d(i)/2.
        else
         pty2d(i)=-999.
         ptey2d(i)=0.
        endif
       enddo
*
       Do i=1,max_xd2
        if (xxd1.ne.0.) then
         y1d(i)=y1d(i)/xxd1/ex1d(i)/2.
         ey1d(i)=ey1d(i)/xxd1/ex1d(i)/2.
        else
         y1d(i)=-999.
         ey1d(i)=0.
        endif
        if (xxd2.ne.0.) then
         y2d(i)=y2d(i)/xxd2/ex2d(i)/2.
         ey2d(i)=ey2d(i)/xxd2/ex2d(i)/2.
        else
         y2d(i)=-999.
         ey2d(i)=0.
        endif
       enddo
*
       if (lp) then
        write(6,*) nd0,' pty1d= ',pty1d
        write(6,*) ndplus,' pty2d= ',pty2d
        write(6,*) ndplus,'  y2d = ', y2d
        write(6,*) nd0,'  y1d = ', y1d
       endif
*
       call hpak ( 1,pty1d)
       call hpake( 1,ptey1d)
       call hpak ( 2,pty2d)
       call hpake( 2,ptey1d)
*
       call hpak (11,y1d)
       call hpake(11,ey1d)
       call hpak (12,y2d)
       call hpake(12,ey1d)
*
       call hzhinfo(11,real(nev))
       call hzhinfo( 1,real(nev))
       call hzhinfo(12,real(nev))
       call hzhinfo( 2,real(nev))
*
       call hzhinrm(101,0,nd0,1)
       call hzhinrm(111,0,nd0,1)
       call hzhinrm(102,0,ndplus,1)
       call hzhinrm(112,0,ndplus,1)
*
       call hzchisq(-1,1)
       call hzchisq(-2,2)
       call hzchisq(-11,11)
       call hzchisq(-12,12)
C       call hzchisq(-1,101)
C       call hzchisq(-2,102)
C       call hzchisq(-11,111)
C       call hzchisq(-12,112)
*
       call hzchisq(-241,241)
       call hzchisq(-242,242)
       call hzchisq(-243,243)
       call hzchisq(-341,341)
       call hzchisq(-342,342)
       call hzchisq(-343,343)
*
       call hzhinfo(241,nnf2cc)
       call hzhinfo(242,nnf2cc)
       call hzhinfo(243,nnf2cc)
       call hzhinfo(341,nnf2cc)
       call hzhinfo(342,nnf2cc)
       call hzhinfo(343,nnf2cc)
*
      endif
      RETURN
      END
