*CMZ :          22/08/2000  10.04.31  by  Tancredi Carli
*-- Author :  H. Jung 25-05-96
      subroutine hz98121(IFLAG)
***********************************************
* F2 data ZEUS DESY 98-121
* Caldwell plot
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact

      Integer iqbin,i1,i3,idhisto,idpaw,idpdf
      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=2000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2
      Real xw
      Data nall/0/
      Data nall2/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real x,y,w2,q2

      double precision dx,dq
      real f2pdf
      DOUBLE PRECISION XXX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20)
      CHARACTER*20 PARM(20)
      Integer npdf
      DATA NPDF/0/,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU/9*0.D0/
      LOGICAL PDFFIRST
      COMMON /W50516/PDFFIRST
*
*
      Real q2min,q2max,lnq2min,lnq2max,lnstep
	Integer nq2bin
	Parameter (nq2bin=26)
      Real q2bin(nq2bin+1)
	data q2bin/  0.11,  0.15,  0.2,  0.25,   0.3,
     +             0.5,   0.6,   0.9,   1.3,   1.9,
     +          	 3.5,   4.5,   6.5,  10.0,  15.0,
     +            22.0,  35.0,  60.0,  90.0, 150.0,
     +           250.0, 450.0, 800.0,1200.0,1500.0,
     +          2000.0,5000.0/
      Real myxbin(26)
	Data myxbin/1.6e-6,
     +     2.1E-6,3.1e-6,4.6e-6,7.3e-6,
     +     1.2E-5,2.0E-5,3.3E-5,6.3E-5,
     +     1.0E-4,1.6E-4,2.5E-4,4.0E-4,6.3e-4,
     +     1.0e-3,1.6e-3,2.5e-3,4.0e-3,6.3e-3,
     +     1.0e-2,1.6e-2,2.5e-2,4.0e-2,8.1e-2,0.2,0.26/

	Real xcenter(25),xbinw(25)
	Data xcenter/
     +     2.1E-6,3.1e-6,4.6e-6,7.3e-6,
     +     1.2E-5,2.0E-5,3.3E-5,6.3E-5,
     +     1.0E-4,1.6E-4,2.5E-4,4.0E-4,6.3e-4,
     +     1.0e-3,1.6e-3,2.5e-3,4.0e-3,6.3e-3,
     +     1.0e-2,1.6e-2,2.5e-2,4.0e-2,8.1e-2,0.2,0.26/
      Real nxbin
	Parameter(nxbin=25)
	
      Integer ixbin
      Real conten(nq2bin+1),contene(nq2bin+1)
	real minq(24),maxq(24)
	data minq/ 0.11,0.15,0.15,0.2 , 0.25,
     +            0.3, 0.3, 0.5, 1.3, 1.3,
     +            1.9, 3.5, 4.5, 6.5, 6.5,
     +            6.5, 6.5,10.0,22.0, 6.5,
     +           22.0, 6.5,10.0,90.0/
      data maxq/ 0.15, 0.2,  0.25,  0.3,
     +            0.6, 0.9,  1.9,   3.5,
     +            6.5, 10.,  15.,   22.,
     +            35., 60.,  90.,  150.,
     +           250.,450., 800., 1200.,
     +          1500.,2000.,5000.,5000./ 	
	real df2(24)
	data df2/0.135, 0.198, 0.174, 0.191, 0.265,
     +         0.297, 0.312, 0.365, 0.379, 0.387,
     +         0.368, 0.429, 0.404, 0.315, 0.262,
     +         0.227, 0.139, 0.150, 0.119, 0.059,
     +         0.061, 0.037, 0.018, 0.008/
	real edf2(24)
	data edf2/0.029,0.028,0.017,0.019,
     +          0.017,0.018,0.009,0.010,
     +          0.018,0.013,0.013,0.018,
     +          0.015,0.014,0.012,0.009,
     +          0.008,0.008,0.012,0.005,
     +          0.008,0.007,0.004,0.010/	

      Real par,step(2),pmin(2),pmax(2),sigpar(2),chi2
	data pmin/0.,0./
	data pmax/100.,100./
	data step/0.01,0.01/
      COMMON/PAWPAR/PAR(2)
	real df2f
	External df2f
	Real df2fit(24)
      real sigm,phip,beta,t,x_pom,xmas,ymas
c      common/cwnco1/x,y,Q2,x_pom,beta,t,phip,xmas,ymas,sigm
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'98121'/

      save Qpi, qqradp, xbinw

*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         write(6,*)' hz98121 my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*
* calculate q2 bin in lnQ2
c         q2min=0.11
c	   q2max=5000.
c	   lnq2min=log(q2min)
c	   lnq2max=log(q2max)
c	   lnstep=(lnq2max-lnq2min)/real(nq2bin)
c	   write(6,*) ' q2 bins '
c	   do I=1,nq2bin+1
c	   q2bin(i)=exp(lnq2min + lnstep*Real(I-1))
c	   enddo
c	   write(6,*) ' q2 bins ',q2bin
	
         myxbin(1)=xcenter(1)-(xcenter(2)-xcenter(1))/2.
         do I = 1,nxbin
            myxbin(i+1) = 2*xcenter(i) - myxbin(i)
         enddo
	
c	   do I=1,nxbin
c	   write(6,*) ' xbinc ',myxbin(i)+(myxbin(i+1)-myxbin(i))/2.,
c     &	   xcenter(i)
c	   enddo
	
	   Do I=1,nxbin
c	   xcenter(i)= myxbin(i) + (myxbin(i+1)-myxbin(i))/2.
	   xbinw(i)=(myxbin(i+1)-myxbin(i))
         Enddo
	
*****************************
*  Make histograms of F2
*****************************
*
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)

         call hbookb( 100,'df2/dlnq2 (mc)',24,xcenter,0.)
         call hbookb( -100,'df2/dlnq2 data stat',24,xcenter,0.)
         call hpak(-100,df2)
         call hpake(-100,edf2)
	
*
         call hbookb( 1001,'f2 x=2.1e-6 ',nq2bin,q2bin,0.)
         call hbookb( 1002,'f2 x=3.1e-6 ',nq2bin,q2bin,0.)
         call hbookb( 1003,'f2 x=4.6e-6 ',nq2bin,q2bin,0.)
         call hbookb( 1004,'f2 x=7.3e-6 ',nq2bin,q2bin,0.)
         call hbookb( 1005,'f2 x=1.2e-5 ',nq2bin,q2bin,0.)
         call hbookb( 1006,'f2 x=2.0e-5 ',nq2bin,q2bin,0.)
         call hbookb( 1007,'f2 x=3.3e-5 ',nq2bin,q2bin,0.)
         call hbookb( 1008,'f2 x=6.3e-5 ',nq2bin,q2bin,0.)
         call hbookb( 1009,'f2 x=1.0e-4 ',nq2bin,q2bin,0.)
         call hbookb( 1010,'f2 x=1.6e-4 ',nq2bin,q2bin,0.)
         call hbookb( 1011,'f2 x=2.5e-4 ',nq2bin,q2bin,0.)
         call hbookb( 1012,'f2 x=4.0e-4 ',nq2bin,q2bin,0.)
         call hbookb( 1013,'f2 x=6.3e-4 ',nq2bin,q2bin,0.)
         call hbookb( 1014,'f2 x=1.0e-3 ',nq2bin,q2bin,0.)
         call hbookb( 1015,'f2 x=1.6e-3 ',nq2bin,q2bin,0.)
         call hbookb( 1016,'f2 x=2.5e-3 ',nq2bin,q2bin,0.)
         call hbookb( 1017,'f2 x=4.0e-3 ',nq2bin,q2bin,0.)
         call hbookb( 1018,'f2 x=6.3e-3 ',nq2bin,q2bin,0.)
         call hbookb( 1019,'f2 x=1.0e-2 ',nq2bin,q2bin,0.)
         call hbookb( 1020,'f2 x=1.6e-2 ',nq2bin,q2bin,0.)
         call hbookb( 1021,'f2 x=2.5e-2 ',nq2bin,q2bin,0.)
         call hbookb( 1022,'f2 x=4.0e-2 ',nq2bin,q2bin,0.)
         call hbookb( 1023,'f2 x=8.1e-2 ',nq2bin,q2bin,0.)
         call hbookb( 1024,'f2 x=0.2    ',nq2bin,q2bin,0.)

c now for pdf
         call hbookb( 2001,'f2 x=2.1e-6 pdf',nq2bin,q2bin,0.)
         call hbookb( 2002,'f2 x=3.1e-6 pdf',nq2bin,q2bin,0.)
         call hbookb( 2003,'f2 x=4.6e-6 pdf',nq2bin,q2bin,0.)
         call hbookb( 2004,'f2 x=7.3e-6 pdf',nq2bin,q2bin,0.)
         call hbookb( 2005,'f2 x=1.2e-5 pdf',nq2bin,q2bin,0.)
         call hbookb( 2006,'f2 x=2.0e-5 pdf',nq2bin,q2bin,0.)
         call hbookb( 2007,'f2 x=3.3e-5 pdf',nq2bin,q2bin,0.)
         call hbookb( 2008,'f2 x=6.3e-5 pdf',nq2bin,q2bin,0.)
         call hbookb( 2009,'f2 x=1.0e-4 pdf',nq2bin,q2bin,0.)
         call hbookb( 2010,'f2 x=1.6e-4 pdf',nq2bin,q2bin,0.)
         call hbookb( 2011,'f2 x=2.5e-4 pdf',nq2bin,q2bin,0.)
         call hbookb( 2012,'f2 x=4.0e-4 pdf',nq2bin,q2bin,0.)
         call hbookb( 2013,'f2 x=6.3e-4 pdf',nq2bin,q2bin,0.)
         call hbookb( 2014,'f2 x=1.0e-3 pdf',nq2bin,q2bin,0.)
         call hbookb( 2015,'f2 x=1.6e-3 pdf',nq2bin,q2bin,0.)
         call hbookb( 2016,'f2 x=2.5e-3 pdf',nq2bin,q2bin,0.)
         call hbookb( 2017,'f2 x=4.0e-3 pdf',nq2bin,q2bin,0.)
         call hbookb( 2018,'f2 x=6.3e-3 pdf',nq2bin,q2bin,0.)
         call hbookb( 2019,'f2 x=1.0e-2 pdf',nq2bin,q2bin,0.)
         call hbookb( 2020,'f2 x=1.6e-2 pdf',nq2bin,q2bin,0.)
         call hbookb( 2021,'f2 x=2.5e-2 pdf',nq2bin,q2bin,0.)
         call hbookb( 2022,'f2 x=4.0e-2 pdf',nq2bin,q2bin,0.)
         call hbookb( 2023,'f2 x=8.1e-2 pdf',nq2bin,q2bin,0.)
         call hbookb( 2024,'f2 x=0.2    pdf',nq2bin,q2bin,0.)
         call hbookb( 200,'df2/dlnq2 pdf',24,xcenter,0.)

*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            return
         endif
*
         q2=real(hzdiskin(1))
         x=real(hzdiskin(2))
         y=real(hzdiskin(3))
         w2=real(hzdiskin(4))
	   if(w2.lt.10) return
         ixbin = -9999
         if(x.lt.myxbin(1).or.x.ge.myxbin(26)) return
         i=0
   50    i=i+1
         if(x.ge.myxbin(i).and.x.lt.myxbin(i+1)) then
            ixbin = i
         else
            goto 50
         endif
         call hfill(221,y,0.,wtx)
         call hfill(222,q2,0.,wtx)
* weighting with photon flux
         xw = x*q2*q2/(1.-y+y**2/2)
         nall2=nall2+xw
         nev(1000+ixbin)=nev(1000+ixbin)+wtx
c         write(6,*) q2,q2b(iqbin),iqbin,xw,wtx
	   if(q2.ge.minq(ixbin).and.q2.le.maxq(ixbin)) then
         call hfill(1000+ixbin,q2,0.,xw*wtx)
	   endif
*
*
*
* determine kin bin of event
*                                             get electron variables
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* fill histos with f2 from pdf

c         do i=1,24
c            do j=1,nq2bin+1

c               dx = dble(xcenter(i))
c               dq = dble(sqrt(q2bin(j)))
c               PARM(1) = 'NPTYPE'
c               VAL(1) = 1.d0
c               PARM(2) = 'NGROUP'
c               VAL(2) = 5.d0
c               PARM(3) = 'NSET'
c               VAL(3) = 7.D0
c               NPDF=NPDF+1
c               PDFFIRST=.FALSE.
c               IF(NPDF.LE.1) PDFFIRST=.TRUE.
c               CALL PDFSET(PARM,VAL)
c               CALL STRUCTM(dx,dq,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,
c     +         GLU)
c               f2pdf=real(4./9.*(upv+usea) + 1./9.*(dnv+dsea) + 8./9.*
c     +         (chm+top) + 2./9.*(str+bot) +
c     +         4./9.*usea + 1./9.*dsea)
c                write(6,*) ' f2pdf ',i,j,xcenter(i),q2bin(j),f2pdf
c	         if(q2bin(j).ge.minq(i).and.q2bin(j).le.maxq(i)) then
c               call hfill(2000+i,q2bin(j),0.,f2pdf)
c       	   endif
c           enddo
c         enddo
c for pdf only	
c determine the Q2 slope of F2 by fitting F2 = a + b*ln(Q2)
c         do idpdf=1,24
c	   df2fit(i1)=0.
c	   idpaw=idpdf+2000
c         call hunpak( idpaw,conten)
c         call hunpke( idpaw,contene)
c	   fact = 0.001
c         do i3=1,nq2bin+1
c            conten(i3)=conten(i3)
c            contene(i3)=contene(i3)
c		write(6,*) idpdf,i3,conten(i3),contene(i3)
c            enddo

c         call hpak( idpaw,conten)
c         call hpake( idpaw,contene)
c         par(1)=0.1
c	   par(2)=0.1
c         call hfith(idpaw,df2f,'QU',2,par)
c	   write(6,*) ' pdf fit ',idpaw,idpdf,par(2)
c         df2fit(idpdf) = par(2)
c         enddo
c	   call hpak(200,df2fit)
         if (lp) then
*
*
* Obtain total cross-section
            write(6,*) ' Total Cross section ',xsec,nall
*
         endif
*
         write(6,*) 'hz',xxxx,': Total Cross section ',xsec,nall
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif

*      normalize the histos
         if(nall2.gt.1) then
* now do the cross section normalisation
            do i1=1,24
		  df2fit(i1)=0.
              idhisto= 1000 +i1
		   idpaw = idhisto
c               call hzhinfo(idpaw,int(nev(idhisto)))
               if(nev(idhisto).gt.1) then
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /xbinw(i1)
c                  write(6,*) ' hz98121 ',idhisto,nev(idhisto)
                  call hzhinrm( idpaw, 0, 1., 1 )
c                  write(6,*) ' hz98121 ',idhisto,nev(idhisto)
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)
c determine the Q2 slope of F2 by fitting F2 = a + b*ln(Q2)
                  par(1)=0.1
			par(2)=0.1
			
c                  call hfith(idpaw,df2f,'QB',2,par,step,pmin,pmax)
ccccccc                  call hfith(idpaw,df2f,'QU',2,par)
            call hfith(idpaw,df2f,'QU',2,par,step,pmin,pmax,sigpar,chi2)
                  df2fit(i1) = par(2)

               endif
            enddo
		call hpak(100,df2fit)
         write(6,*) ' end of hz',xxxx
         endif
*
*
*
      endif
      RETURN
      END
      FUNCTION df2f(X)
	Double Precision DPAR(24),FITFUN
	Common/HCFITD/DPAR,FITFUN
c      COMMON/PAWPAR/PAR(2)
c	write(6,*) ' df2f par ',dpar(1),dpar(2)
c      df2f=PAR(1)+PAR(2)*LOG(X)
       FITFUN=DPAR(1) + DPAR(2)*LOG(X)
	df2f=FITFUN
      END

