*CMZ :  2.00/04 31/07/2000  21.11.45  by  Tancredi Carli
*CMZ :  0.05/00 16/12/91  20.44.49  by  M. Erdmann
*-- Author :    C. Jacobsson   24/07/91
*-- Author :    G. KNIES       24/07/91
      SUBROUTINE HGDECO(NAMOUT,JETFU,MAXML,NCON,NPRI,IFLAG)
************************************************************************
*      QGDECO IS THE MAIN ROUTINE FOR EVENT DECOMPOSITION
*      HGDECO is for use in HZTOOL environment, 15/02/99, G.K.
**         when called in H1PHAN, from sr. QJDECO
*      the input arguments are
*       NAMOUT CHARACTER*7 the multiplet (jet)name given in HZ97210
C14/02/99 or in HZ97210
*       NAMOUT characters 1..4 are used as name for multiplet banks
*       eg. NAMOUT='MSQDECO' using m**2 as jet function in DECo method
*        the result for multiplet L then is in qctbuf/ ..,qpo(,)
*        the jets of multiplet L listen to 'MSQDECOL', L=2,3,4,or 5
*            in H1PHAN.
*
*       JETFU  selects the topological function
*              1=invariant n-dimensional thrust
*              3=sum of jet masses
*              4=sum of jet (masses)**2
*       MAXML  set the maximum of jet multiplicity up to which DECO goes
*               2=< MAXMUL<=5
*       NPRI   print out level: 0=none,1=jet results,2=details for debug
*       IFLAG  NE.0  if no decomposition done because of problems
*
*D: QGDECO 00500 gk. cosmetics
c14/02/99  call for QEDECI removed, is transferred to sr HZ97210
******************************************************************

#include "qjmacs.inc"
#include "decoma.inc"
*
      CHARACTER*4 NJETFU
      CHARACTER*7 NAMOUT
      DATA NCALL/0/
      NCALL=NCALL+1
      IFLAG=0
      MEVENT=NCALL
      MODE=1
C  to be set by user
      NEVPRI=NPRI
      MAXMUL=MAXML
      IF(NCALL.LE.1)
     1PRINT *,'*** ART DECO for EVENT DECOMPOSITION into JETS ***'
      IF(NCALL.LE.1)
     2PRINT *,' *** TOPOL FU NR.',JETFU,'MAX. MULTIPLET=',MAXML,'***'
      IF(NPRI.GE.1)
     1PRINT *,'* ART DECO CALL#',NCALL,'JETFU#',JETFU,'MAXMUL=',MAXML
*      CALL HEDECI(MODE,IFLAG)
*        SUBROUTINE EDECI (NAMIN.NUMIN,MODE,NCON,IFLAG)
*       IF (IFLAG.NE.0) THEN
*        PRINT *,'DECO INITIALISATION FAILED FOR EVENT:',NCALL
*        RETURN
*       ENDIF
      ICMS=0
      INIMU=-1
      IPREV=1
      IREVER=NCON
      NJETFU=NAMOUT(:4)
      CALL HEDECO(JETFU,NJETFU,ICMS,INIMU,IPREV,IREVER)
      INDEX=1
      CALL HEDECX(IFLAG)
      IF (IFLAG.NE.0) PRINT *,'** ERROR ** IN EDECX'
      RETURN
      END
