*CMZ :  1.00/03 13/03/96  17.24.58  by  Mark Hayes
*-- Author :
      SUBROUTINE hzjetrad(iflag,radi)
***********************************************************************
* Purpose: To set jet finder radii & find out the radius
*
* To set radius
*	INPUT   iflag=1
*		radi=radius to be set (in radians)
*	OUTPUT  radi=-1 everything OK!
* To read the radius
*	INPUT   iflag=2
*	OUTPUT  radi=returns radius (in radians)
*			or negative if cone radius not set by user
* Author: M. Hayes
***********************************************************************
      Implicit None

#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"

      INTEGER iflag
      DOUBLE PRECISION radi,radius
      DATA radius/-1.0/
      SAVE radius

      IF (iflag.eq.1) THEN
C --- set radius
	IF ((radi.gt.0).and.(radi.lt.3.14)) THEN
	  radius=radi
	ELSE
	  radi=-1
	  PRINT*,'HZJETRAD : silly cone radius set'
	ENDIF
      ELSEIF (iflag.eq.2) THEN
C --- read radius
	radi=radius
      ELSE
      	radi=-1
      	PRINT*,'HZJETRAD : badly set iflag'
      ENDIF

      Return
      End
