**********************************************************   
* This Subroutine calculates X_gamma and M(D*+Jet) and fills their histograms

      Subroutine HzCalculus (NumD, JetN, Xgamma, iel)
      IMPLICIT NONE

*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzjetcmn.inc"
*
      
      Integer I, NumD, JetN, iel
      Double Precision JetSum, HFSsum, Xgamma, Masse
      
      HFSSum = 0
      JetSum = 0
      
      Do I=1, NHEP
         If (I.ne.iel) Then
* Sumation over all HFS
            If (ISTHEP(I).eq.1) HFSsum= HFSsum + (PHEP(4,I) - PHEP(3,I))
* Sumation over Jet       
            If (IJETNO(I).eq.JetN) Then
               JetSum= JetSum + (PHEP(4,I) - PHEP(3,I))
            End If  
	 End If  
      End Do

      Masse = sqrt((PHEP(4,NumD)+Jets(JetN,4))**2-
     &     ((PHEP(1,NumD)+Jets(JetN,5))**2+
     &     (PHEP(2,NumD)+Jets(JetN,6))**2+
     &     (PHEP(3,NumD)+Jets(JetN,7))**2))

      call hfill(480,real(Masse),0.,real(wtx))
*       If (Masse.lt.5.5.or.Masse.gt.28.) Write(*,*) 'Masse ', Masse	  
       
      Xgamma = (( PHEP(4,NumD) - PHEP(3,NumD) ) + JetSum)/HFSsum
      call hfill(470,real(Xgamma),0.,real(wtx))	  
*       If (Xgamma.lt.0..or.Xgamma.gt.1.) Write(*,*) 'Xgamma ', Xgamma	  
       
      Return
      End
