*CMZ :  2.00/06 02/05/2002  14.54.18  by  Tancredi Carli
*CMZ :  0.00/03 08/01/96  16.56.39  by  HZtool
*CMZ :  0.00/01 05/01/96  14.14.22  by  HZtool
*-- Author :
      FUNCTION HZLCHGE(KF)
******************************************************************
*Purpose: to give three times the charge for a particle/parton.
* Input: KF particle code
*Output:
*Author: N. Brook
******************************************************************
#include "hzdat.inc"
#include "hzfunc.inc"
*
      Integer Loca(500,3)
      Logical Init,lp
      Data Init /.true./,lp/.false./
      DATA (LOCA(I,1),I=   1, 500)/-1,2,-1,2,-1,2,-1,2,2*0,-3,0,-3,0,
     &-3,0,-3,6*0,3,9*0,3,2*0,3,0,-1,44*0,2,-1,2,-1,2,3,11*0,3,0,2*3,0,
     &3,0,3,0,3,10*0,3,0,2*3,0,3,0,3,0,3,10*0,3,0,2*3,0,3,0,3,0,3,10*0,
     &3,0,2*3,0,3,0,3,0,3,10*0,3,0,2*3,0,3,0,3,0,3,10*0,3,0,2*3,0,3,0,
     &3,0,3,70*0,3,0,3,28*0,3,2*0,3,8*0,-3,8*0,3,0,-3,0,3,-3,3*0,3,6,0,
     &3,5*0,-3,0,3,-3,0,-3,4*0,-3,0,3,6,-3,0,3,-3,0,-3,0,3,6,0,3,5*0,
     &-3,0,3,-3,0,-3,114*0/
      DATA (LOCA(I,2),I=   1, 500)/8*1,12*0,2,16*0,2,1,50*0,-1,410*0/
      DATA (LOCA(I,3),I=   1, 500)/8*1,2*0,8*1,5*0,1,9*0,1,2*0,1,0,2*1,
     &41*0,1,0,7*1,10*0,10*1,10*0,10*1,10*0,10*1,10*0,10*1,10*0,10*1,
     &10*0,10*1,70*0,3*1,22*0,1,5*0,1,0,2*1,6*0,1,0,2*1,6*0,2*1,0,5*1,
     &0,6*1,4*0,6*1,4*0,16*1,4*0,6*1,114*0/
*
      If(Init) Then
        Init = .false.
C        Call Ucopy(loca,kchg,1500)
         Do i=1,500
          kchg(i,1)=loca(i,1)
          kchg(i,2)=loca(i,2)
          kchg(i,3)=loca(i,3)
         enddo
      Endif
C...Initial values. Simple case of direct readout.
      HZLCHGE=0
      KFA=IABS(KF)
      KC=HZLCOMP(KFA)
*
      if (lp) then
       write(6,*) ' kfa = ',kfa,' kc= ',kc
      endif
*
      IF(KC.EQ.0) THEN
      ELSEIF(KFA.LE.100.OR.KC.LE.80.OR.KC.GT.100) THEN
        HZLCHGE=KCHG(KC,1)

C...Construction from quark content for heavy meson, diquark, baryon.
      ELSEIF(MOD(KFA/1000,10).EQ.0) THEN
        HZLCHGE=(KCHG(MOD(KFA/100,10),1)-KCHG(MOD(KFA/10,10),1))*
     &  (-1)**MOD(KFA/100,10)
      ELSEIF(MOD(KFA/10,10).EQ.0) THEN
        HZLCHGE=KCHG(MOD(KFA/1000,10),1)+KCHG(MOD(KFA/100,10),1)
      ELSE
        HZLCHGE=KCHG(MOD(KFA/1000,10),1)+KCHG(MOD(KFA/100,10),1)+
     &  KCHG(MOD(KFA/10,10),1)
      ENDIF

C...Add on correct sign.
      HZLCHGE=HZLCHGE*ISIGN(1,KF)
      if (lp) then
       write(6,*) ' kf= ',kf,' hzlchge= ',HZLCHGE
      endif
      RETURN
      END
