*CMZ :  0.00/01 05/01/96  21.29.22  by  HZtool
*-- Author :
       Subroutine Hzphmrot(phi,the,p,pnew)
C#*****************************************************************
C#       Subroutine hzphmrot(phi,the,p,pnew)
C#
C#  HZPHMROT : Performs rotations in space
C#
C#  PURPOSE :  Performs rotations in space
C#
C# INPUT :
C#  PHI, THE =
C#       are standard polar coords. ,phi and theta, giving
C#       the direction of a momentum vector initially along the
C#       +ve z axis.
C#
C#   P       =  is the vector to be acted upon
C# OUTPUT :
C#   PNEW    =  is the rotated vector
C#
C# Author: LUROBO in JETSET (modified by N Brook)
C#
C#****************************************************************
       Implicit DOUBLE PRECISION(A-H,O-Z)
       Dimension rot(3,3), p(3), pnew(3), ptmp(3)
*
       do Ivec = 1, 3
         pnew(ivec) = p(ivec)
         ptmp(ivec) = p(ivec)
       enddo
       IF(THE**2+PHI**2.GT.1E-20) THEN
C...ROTATE (TYPICALLY FROM Z AXIS TO DIRECTION THETA,PHI)
         ROT(1,1)=COS(THE)*COS(PHI)
         ROT(1,2)=-SIN(PHI)
         ROT(1,3)=SIN(THE)*COS(PHI)
         ROT(2,1)=COS(THE)*SIN(PHI)
         ROT(2,2)=COS(PHI)
         ROT(2,3)=SIN(THE)*SIN(PHI)
         ROT(3,1)=-SIN(THE)
         ROT(3,2)=0.
         ROT(3,3)=COS(THE)
         DO 110 J=1,3
 110     PNEW(J)=ROT(J,1)*PTMP(1)+ROT(J,2)*PTMP(2)+ROT(J,3)*PTMP(3)
       ENDIF
       RETURN
       END
