*CMZ :  1.02/02 23/10/98  11.02.43  by  Tancredi Carli
*-- Author :
      FUNCTION HzPt (ipart)
************************************************************************
*     input:  ipart:        index of particle in HEP common
*     output: return value: transverse momentum of particle
*     no other subroutines are called
*     written by: Andreas von Manteuffel
************************************************************************

      IMPLICIT NONE

#include "hepevtp.inc"

      Double Precision HzPt
      Integer ipart
      Double Precision dpx, dpy, dpt

c --- check particle index
      if ((ipart.lt.1).or.(ipart.gt.NHEP)) then
         dpt = 0.D0
      else

c --- get particle pt
         dpx = PHEP(1,ipart)
         dpy = PHEP(2,ipart)
         dpt = SQRT(dpx**2+dpy**2)

      endif

      HzPt = dpt

      RETURN
      END
