*CMZ :  1.01/15 22/06/98  15.35.32  by  Tancredi Carli
*CMZ :  1.01/10 11/11/97  17.30.21  by  Tancredi Carli
*CMZ :  0.00/10 19/02/96  10.09.59  by  Tancredi Carli
*CMZ :  0.00/08 13/02/96  18.43.56  by  Tancredi Carli
*-- Author :
      Subroutine Hzterm
********************************************************************
*                                                                  *
* Hzterm                                                           *
* ======                                                           *
* Authour: Nick Brook.                                             *
*                                                                  *
* Scans through sub-directories and prints out the Chi-sq, Ndof    *
* for each histogram in a nice little table                        *
*                                                                  *
********************************************************************
 
      Implicit None
*
      Integer Maxdir
      Parameter(Maxdir=40)
      Character*8 chdir(maxdir)
      Integer Ndir, Idir, Ievt, Nevt,idn,ierr
      Real evt(3)
      Logical Hexist
      Character rout*10
      Data rout/'hzterm '/
*
      Call hcdir('//PAWC',' ')
      Call Hrdir(maxdir,chdir,ndir)
      If(ndir.gt.maxdir) Write(6,*) rout,' Number of directories > ',
     +  maxdir, ' only first ',maxdir, ' outputted'
*
       Do Idir = 1, min(ndir,maxdir)
         call hcdir(chdir(idir),' ')
         Write(6,*) ' Subdirectory: ',chdir(idir)
         Write(6,*) ' ======================'
         Write(6,*) ' '
         if(hexist(999)) Then
           Write(6,1000)
           Call Hgnpar(999,'HZTERM')
           Call Hnoent(999,nevt)
           Do Ievt = 1, Nevt
             Call Hgnf(999,ievt,evt,ierr)
             Write(6,1001) int(evt(1)),evt(2),int(evt(3))
           Enddo
           Write(6,1002)
         Endif
         Call hcdir(' \ ',' ')
       Enddo
*
       Return
*
 1000  Format(10X,30('*')/10x,'*',10x,'*',10x,'*',6x,'*'/
     1        10x,'* HISTO ID *   chi-2  *  NdF *'/
     +        10x,'*',10x,'*',10x,'*',6x,'*'/10X,30('*')/
     2        10x,'*',10x,'*',10x,'*',6x,'*')
 1001  Format(10X,'* ',I8,' * ',F8.2,' * ',I4,' *')
 1002  Format(10x,'*',10x,'*',10x,'*',6x,'*'/10X,30('*')/' ')
       End
