 
      subroutine ZSrho (id, chtitl, rho, erra, errtu, errtd)
*****************************************************************************
*     Subroutine ZSrho builds up 3 histos with ZEUS data:
*       Histo-ID = - (100+id)  for statist. errors (erra) only
*                = - (300+id)  for total up errors (errtu)
*                = - (400+id)  for total down errors (errtd)
*
 
      Implicit None
 
      Integer      id
      Real         rho, erra, errtu, errtd
      Character*80 chtitl
      Dimension rho(10)
      Dimension erra(10)
      Dimension errtu(10)
      Dimension errtd(10)
 
      call hbook1(-100-id, chtitl, 10, 0.00, 1.00, 0.)
      call hpak(-100-id, rho)
      call hpake(-100-id, erra)
 
      call hbook1(-300-id, chtitl, 10, 0.00, 1.00, 0.)
      call hpak(-300-id, rho)
      call hpake(-300-id, errtu)
 
      call hbook1(-400-id, chtitl, 10, 0.00, 1.00, 0.)
      call hpak(-400-id, rho)
      call hpake(-400-id, errtd)
 
      end
