*CMZ :          14/02/99  13.03.21  by  Hannes Jung
*CMZ :  1.01/13 19/03/98  08.27.21  by  Hannes Jung
*-- Author :    Hannes Jung   19/03/98
      subroutine HZGAMAD(IFLAG)
****************************************************************************
* Purpose: to add virtual gamma to event record for PYTHIA and POMPYT
* written by: Hannes Jung on 19/03/98
* corrected to pick out only the first stable electron
****************************************************************************
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Commonblocks.
* include LUJETS common
      Real P,V
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
* include pythia6 pyjets common
      double precision PP,VP
      COMMON/PYJETS/NP,NPAD,KP(4000,5),PP(4000,5),VP(4000,5)
*
      ISCAT = -999
* find scattered electron
      IF(N.GT.0) THEN
         DO I=1,N
            IF(K(I,1).eq.1.and.abs(K(I,2)).eq.11) then
               iscat = I
               goto 111
            endif
         ENDDO
 111     Continue        
         IF(ISCAT.GT.0) THEN
            DO J = 1,4
               P(N+1,J) = P(2,J) - P(ISCAT,J)
            ENDDO
            P(N+1,5) = P(N+1,4)**2 - P(N+1,1)**2 - P(N+1,2)**2 - P(N+1,
     +      3)**2
            P(N+1,5) = -SQRT(ABS(P(N+1,5)))
            K(N+1,1) = 21
            K(N+1,2) = 23
            K(N+1,3) = 1
            N = N+1
         ENDIF
      ELSEIF(NP.GT.0) THEN
         DO I=1,NP
            IF(KP(I,1).eq.1.and.abs(KP(I,2)).eq.11) then
               iscat = I
               goto 112
            endif
         ENDDO
 112     Continue        
         IF(ISCAT.GT.0) THEN
            DO J = 1,4
               PP(N+1,J) = PP(2,J) - PP(ISCAT,J)
            ENDDO
            PP(NP+1,5) =PP(NP+1,4)**2-PP(NP+1,1)**2-PP(NP+1,2)**2-
     +      PP(NP+1,3)**2
            PP(NP+1,5) = -DSQRT(DABS(PP(NP+1,5)))
            KP(NP+1,1) = 21
            KP(NP+1,2) = 23
            KP(NP+1,3) = 1
            NP = NP+1
         ENDIF
      ELSE
         write(6,*) ' cannot determine LUJETS or PYJETS common '
      ENDIF

      RETURN
*
      END
