*CMZ :  2.00/00 13/08/99  17.14.37  by  Tancredi Carli
*CMZ :  1.01/15 04/06/98  2
*-- Author :
      subroutine Had_to_HCM(nch)
c
c  Boost Hadrons to HCM frame (G. Cases: 3.11.95)
c
 
      Implicit None
 
#include "pucell.inc"

      integer nch,i,istable
      real PT,Theta,eta,Phi
      real deg,pi
      real fbeam_pipe,rbeam_pipe
      pi=3.141592654
      fbeam_pipe=0.
      rbeam_pipe=180.
      deg=180./pi
 
c       istable=100+nch
       istable=100
c
      if(nch.gt.0) then
c        call lor(1,5,15)
c        call lor(2,5,14)
c        call lor(3,5,16)
c        call lor(4,5,13)
        do i=1,nch
c          call lor(100+i,5,istable+i) ! boost
c---
          PT=sqrt(pucellp(1,istable+i)**2+pucellp(2,istable+i)**2)
          Theta=acos(pucellp(3,istable+i)
     +          /sqrt(PT**2+pucellp(3,istable+i)**2))
          eta=-alog(tan(theta/2.))
          PHI=atan2(PUCELLP(2,istable+i),PUCELLP(1,istable+i))
          if (PHI.lt.0.) then
              PHI = PHI + 2*3.141592654
          endif
c          if(theta*deg.gt.fbeam_pipe.and.theta*deg.lt.rbeam_pipe)
c     +                             then
          pucellp(6,istable+i)=ETA
          pucellp(7,istable+i)=PT
          pucellp(8,istable+i)=PHI
c
c---
c          endif
        enddo
      endif
c
      return
      end
