      FUNCTION HzDr (ipart1,ipart2)
************************************************************************
*     input:  ipart1:        index of particle 1 in HEP common
*     input:  ipart2:        index of particle 2 in HEP common
*
*     return value: deltaR = sqrt (deta^2 + dphi^2) between particles 
*     
*     written by: Oliver Gutsche
************************************************************************
      IMPLICIT NONE
 
#include "hepevtp.inc"
#include "hzfunc.inc"
 
      Integer ipart1,ipart2

      DOUBLE PRECISION dr

c     particle indices are checked in hzdeta() and hzdphi()

      HzDr = sqrt ( HZDETA(ipart1,ipart2)**2 +
     +     HZDPHI(ipart1,ipart2)**2 )
 
      RETURN
      END
















