*
*CMZ :  1.01/11 20/11/97  13.58.19  by  Tancredi Carli
*CMZ :  1.01/07 08/10/97  17.27.54  by  Tancredi Carli
*CMZ :  1.01/05 03/09/96  16.37.58  by  Tancredi Carli
*-- Author :
      Subroutine HzHInfo(idmc,nbin)
*********************************************************************
*                                                                   *
* Fills some information in an ntuple                               *
*
* Author: Tancredi Carli                                            *
*                                                                   *
* Input arguments:                                                  *
* Idmc  - Histogram ID of Monte Carlo                               *
*                                                                   *
* Output arguments:                                                 *
* none                                                              *
*                                                                   *
*********************************************************************
*
      Implicit None
*
      Integer Ndatpts
      Parameter(Ndatpts=1000)
      Integer idmc
      Real nbin
      Logical Hexist,lp
      Character rout*10
      Integer ntag,ntid
      Parameter (ntag=2,ntid=998)
      Real evt(ntag)
      Character*4 tags(ntag)
      Data Tags/'id','Norm'/
      Data lp/.false./
*
      If(.not.Hexist(ntid)) then
       Call Hbookn(ntid,' Histo info',ntag,' ',100,Tags)
       if (lp) write(6,*) rout,' book ntuple ',ntid
      endif
*
      evt(1) = real(idmc)
      evt(2) = nbin
*
      if (lp) then
       write(6,*) rout,ntid,' filling = ',evt
      endif
*
      Call hfn(ntid,evt)
*
      Return
      End
