*==========================================================

      SUBROUTINE hzkhisfil(i1,i2,x,w1,w2,w3,n2,ioffset,wtx)
c
c       Fill appropriate histogram
c       Input:  i1, i2,(i3)... bin number of appropriate variable
c               x          ... value of the third (last) variable 
c                              (x will be filled into the histogram)
c               w1, w2, w3 ... bin widths
c               n2         ... number of bins of the second varible (maximum possible i2)
c               ioffset    ... offset (last 2 digits in histogram numbering)
c               wtx        ... weight of the event
c
      implicit none
      
      integer   i1,i2,i3,n2,ioffset
      real      w1,w2,w3,x,wtx

      integer   const,id
      parameter(const=40000)
      real      weight

      if ((i1.gt.0).and.(i2.gt.0)) then
        id=const+((i1-1)*n2+i2)*100 +ioffset
        weight=wtx/(w1*w2*w3)
*        write(*,*)'w1,w2,w3,weight=',w1,w2,w3,weight
        call hfill(id,x,0.,weight)
      endif

      return
      END
*==========================================================
