      SUBROUTINE HZNMI(etcut,n,error)
c     -------------------------------
c     Give it an transverse energy cut (ETCUT) in GeV and it will
c     return the number of hard scatters in the event above the cut.
c     (Actually this routine just administrates the generator specific 
c     routines).
c
c     Jon Butterworth 4/3/2000
c     ------------------------
      IMPLICIT NONE

#include "hepevtp.inc"
#include "heracmn.inc"

      INTEGER n, error
      DOUBLE PRECISION etcut

      error=0
      n=0

      IF (gen(1:3).EQ.'HRW') THEN

         CALL HZHRWNMI(etcut,n,error)

      ELSE IF (gen(1:3).EQ.'PYT') THEN

         CALL HZPYTNMI(etcut,n,error)

      ELSE
         WRITE(*,*) 'HZNMI: Unrecognized generator ',GEN
         error=1
         RETURN
      ENDIF

      RETURN
      END
