*CMZ :  0.00/01 05/01/96  14.08.20  by  HZtool
*-- Author :
      FUNCTION HZPHMANG(X,Y)
C#*****************************************************************
C#  HZPHMANG : Returns an angle between -pi and +pi
C#  PURPOSE : Returns an angle between -pi and +pi
C#                                                               *
C# Returns an angle between -pi and +pi                          *
C#                                                               *
C# Theta: getang(z,sqrt(x**2+y**2))   0. < theta < pi            *
C# Phi  : getang(x,y)                -pi <  phi  < pi            *
C#                                                               *
C# Author: ULANGL in JETSET (modified by N Brook)                *
C#                                                               *
C#*****************************************************************
      Implicit DOUBLE PRECISION(A-H,O-Z)
#include "hzfunc.inc"
*
      data pi /3.141592654/
      HZPHMANG=0.
C...RECONSTRUCT THE ANGLE FROM X AND Y COORDINATES
      R=SQRT(X**2+Y**2)
      IF(R.LT.1E-20) RETURN
      IF(ABS(X)/R.LT.0.8) THEN
        HZPHMANG=SIGN(ACOS(X/R),Y)
      ELSE
        HZPHMANG=ASIN(Y/R)
      IF(X.LT.0..AND.HZPHMANG.GE.0.) THEN
        HZPHMANG=PI-HZPHMANG
      ELSEIF(X.LT.0.) THEN
        HZPHMANG=-PI-HZPHMANG
      ENDIF
      ENDIF
      RETURN
      END
