 
 
 
      subroutine ZSpsifxd (iid,chtitl,incx,xbins,psi,erra,errtu,errtd)
************************************************************************
*     Subroutine ZSpsifxd builds up 3 histos with ZEUS data:
*       Histo-ID = - (100+id)  for statist. errors (ae) only
*                = - (300+id)  for total up errors (errtu)
*                = - (400+id)  for total down errors (errtd)
*
 
      Implicit None
 
      Integer      iid, incx
      Real         psi, erra, errtu, errtd, xbins
      Character*80 chtitl
      Dimension xbins(incx+1)
      Dimension psi(incx)
      Dimension erra(incx)
      Dimension errtu(incx)
      Dimension errtd(incx)
 
      call hbookb(-100-iid, chtitl, incx, xbins, 0.)
      call hpak(-100-iid, psi)
      call hpake(-100-iid, erra)
 
      call hbookb(-300-iid, chtitl, incx, xbins, 0.)
      call hpak(-300-iid, psi)
      call hpake(-300-iid, errtu)
 
      call hbookb(-400-iid, chtitl, incx, xbins, 0.)
      call hpak(-400-iid, psi)
      call hpake(-400-iid, errtd)
 
      end
